# -*- Autoconf -*-
#
# Copyright (c) 2005-2006 The ABINIT Group (Yann Pouillon)
# All rights reserved.
#
# This file is part of the ABINIT software package. For license information,
# please see the COPYING file in the top-level directory of the ABINIT source
# distribution.
#

# Generated by make-macros-extlibs on 2006/11/28 06:12:42 +0000

#
# Command-line options for the "configure" script
#

#
# IMPORTANT NOTE
#
# This file has been automatically generated by the make-macros-extlibs
# script. If you try to edit it, your changes will systematically be
# overwritten.
#



# ABI_EXTLIB_LINALG()
# -------------------
#
# Sets all variables needed to handle the LINALG external library.
#
AC_DEFUN([ABI_EXTLIB_LINALG],
[dnl Initial setup
 linalg_include=""
 linalg_ldflags=""

 dnl Define variables needed to build the library
 if test -z "${CPPFLAGS_LINALG}"; then
  CPPFLAGS_LINALG=""
 fi
 AC_SUBST(CPPFLAGS_LINALG)
 if test -z "${CFLAGS_LINALG}"; then
  CFLAGS_LINALG=""
 fi
 AC_SUBST(CFLAGS_LINALG)
 if test -z "${CXXFLAGS_LINALG}"; then
  CXXFLAGS_LINALG=""
 fi
 AC_SUBST(CXXFLAGS_LINALG)
 if test -z "${FCFLAGS_LINALG}"; then
  FCFLAGS_LINALG=""
 fi
 AC_SUBST(FCFLAGS_LINALG)

 dnl Output library status
 AC_MSG_CHECKING([whether to use the LINALG library])
 AC_MSG_RESULT([${enable_linalg}])

 dnl Determine what to do
 if test "${enable_linalg}" = "yes"; then
  AC_DEFINE([HAVE_LINALG],1,[Define to 1 if you want to use the LINALG bindings])

  if test "${with_linalg_ldflags}" = "" -o "${enable_extlibs}" = "no"; then
   linalg_ldflags="-L\$(top_builddir)/lib/linalg -llinalg"
   build_linalg="yes"

   if test "${enable_tricks}" = "yes"; then
    ABI_TRICKS_LINALG(${linalg_type})
    if test "${linalg_tricks_bypass}" = "yes"; then
     build_linalg="no"
    fi
   fi
  else
   linalg_ldflags="${with_linalg_ldflags}"
   build_linalg="no"
  fi
 else
  build_linalg="no"
 fi

 dnl Output result
 AC_MSG_CHECKING([whether to build the LINALG library])
 AC_MSG_RESULT([${build_linalg}])

 dnl Substitute variables needed for the use of the library
 AC_SUBST(linalg_include)
 AC_SUBST(linalg_ldflags)
 AC_SUBST(build_linalg)

 dnl Inform Automake
 AM_CONDITIONAL(DO_BUILD_LINALG,test "${build_linalg}" = "yes")
 AM_CONDITIONAL(DO_ENABLE_LINALG,test "${enable_linalg}" = "yes")
]) # ABI_EXTLIB_LINALG



# ABI_EXTLIB_NETCDF()
# -------------------
#
# Sets all variables needed to handle the NETCDF external library.
#
AC_DEFUN([ABI_EXTLIB_NETCDF],
[dnl Initial setup
 netcdf_include=""
 netcdf_ldflags=""

 dnl Define variables needed to build the library
 if test -z "${CPPFLAGS_NETCDF}"; then
  CPPFLAGS_NETCDF=""
 fi
 AC_SUBST(CPPFLAGS_NETCDF)
 if test -z "${CFLAGS_NETCDF}"; then
  CFLAGS_NETCDF=""
 fi
 AC_SUBST(CFLAGS_NETCDF)
 if test -z "${CXXFLAGS_NETCDF}"; then
  CXXFLAGS_NETCDF=""
 fi
 AC_SUBST(CXXFLAGS_NETCDF)
 if test -z "${FCFLAGS_NETCDF}"; then
  FCFLAGS_NETCDF=""
 fi
 AC_SUBST(FCFLAGS_NETCDF)

 dnl Output library status
 AC_MSG_CHECKING([whether to use the NETCDF library])
 AC_MSG_RESULT([${enable_netcdf}])

 dnl Determine what to do
 if test "${enable_netcdf}" = "yes"; then
  AC_DEFINE([HAVE_NETCDF],1,[Define to 1 if you want to use the NETCDF bindings])

  if test "${with_netcdf_include}" = "" -o "${with_netcdf_ldflags}" = "" -o           "${enable_extlibs}" = "no"; then
   netcdf_include="-I\$(top_builddir)/lib/netcdf"
   netcdf_ldflags="-L\$(top_builddir)/lib/netcdf -lnetcdf"
   build_netcdf="yes"

   if test "${enable_tricks}" = "yes"; then
    ABI_TRICKS_NETCDF(${fc_type},${fc_version})
    if test "${netcdf_tricks_bypass}" = "yes"; then
     build_netcdf="no"
    fi
   fi
  else
   netcdf_include="${with_netcdf_include}"
   netcdf_ldflags="${with_netcdf_ldflags}"
   build_netcdf="no"
  fi
 else
  build_netcdf="no"
 fi

 dnl Output result
 AC_MSG_CHECKING([whether to build the NETCDF library])
 AC_MSG_RESULT([${build_netcdf}])

 dnl Substitute variables needed for the use of the library
 AC_SUBST(netcdf_include)
 AC_SUBST(netcdf_ldflags)
 AC_SUBST(build_netcdf)

 dnl Inform Automake
 AM_CONDITIONAL(DO_BUILD_NETCDF,test "${build_netcdf}" = "yes")
 AM_CONDITIONAL(DO_ENABLE_NETCDF,test "${enable_netcdf}" = "yes")
]) # ABI_EXTLIB_NETCDF



# ABI_EXTLIB_NQXC()
# -----------------
#
# Sets all variables needed to handle the NQXC external library.
#
AC_DEFUN([ABI_EXTLIB_NQXC],
[dnl Initial setup
 nqxc_include=""
 nqxc_ldflags=""

 dnl Define variables needed to build the library
 if test -z "${CPPFLAGS_NQXC}"; then
  CPPFLAGS_NQXC=""
 fi
 AC_SUBST(CPPFLAGS_NQXC)
 if test -z "${CFLAGS_NQXC}"; then
  CFLAGS_NQXC=""
 fi
 AC_SUBST(CFLAGS_NQXC)
 if test -z "${CXXFLAGS_NQXC}"; then
  CXXFLAGS_NQXC=""
 fi
 AC_SUBST(CXXFLAGS_NQXC)
 if test -z "${FCFLAGS_NQXC}"; then
  FCFLAGS_NQXC=""
 fi
 AC_SUBST(FCFLAGS_NQXC)

 dnl Output library status
 AC_MSG_CHECKING([whether to use the NQXC library])
 AC_MSG_RESULT([${enable_nqxc}])

 dnl Determine what to do
 if test "${enable_nqxc}" = "yes"; then
  AC_DEFINE([HAVE_NQXC],1,[Define to 1 if you want to use the NQXC bindings])

  if test "${with_nqxc_include}" = "" -o "${with_nqxc_ldflags}" = "" -o           "${enable_extlibs}" = "no"; then
   nqxc_include="-I\$(top_builddir)/lib/nqxc"
   nqxc_ldflags="-L\$(top_builddir)/lib/nqxc -lnqxc"
   build_nqxc="yes"

   if test "${enable_tricks}" = "yes"; then
    ABI_TRICKS_NQXC()
    if test "${nqxc_tricks_bypass}" = "yes"; then
     build_nqxc="no"
    fi
   fi
  else
   nqxc_include="${with_nqxc_include}"
   nqxc_ldflags="${with_nqxc_ldflags}"
   build_nqxc="no"
  fi
 else
  build_nqxc="no"
 fi

 dnl Output result
 AC_MSG_CHECKING([whether to build the NQXC library])
 AC_MSG_RESULT([${build_nqxc}])

 dnl Substitute variables needed for the use of the library
 AC_SUBST(nqxc_include)
 AC_SUBST(nqxc_ldflags)
 AC_SUBST(build_nqxc)

 dnl Inform Automake
 AM_CONDITIONAL(DO_BUILD_NQXC,test "${build_nqxc}" = "yes")
 AM_CONDITIONAL(DO_ENABLE_NQXC,test "${enable_nqxc}" = "yes")
]) # ABI_EXTLIB_NQXC



# ABI_EXTLIB_XMLF90()
# -------------------
#
# Sets all variables needed to handle the XMLF90 external library.
#
AC_DEFUN([ABI_EXTLIB_XMLF90],
[dnl Initial setup
 xmlf90_include=""
 xmlf90_ldflags=""

 dnl Define variables needed to build the library
 if test -z "${CPPFLAGS_XMLF90}"; then
  CPPFLAGS_XMLF90=""
 fi
 AC_SUBST(CPPFLAGS_XMLF90)
 if test -z "${CFLAGS_XMLF90}"; then
  CFLAGS_XMLF90=""
 fi
 AC_SUBST(CFLAGS_XMLF90)
 if test -z "${CXXFLAGS_XMLF90}"; then
  CXXFLAGS_XMLF90=""
 fi
 AC_SUBST(CXXFLAGS_XMLF90)
 if test -z "${FCFLAGS_XMLF90}"; then
  FCFLAGS_XMLF90=""
 fi
 AC_SUBST(FCFLAGS_XMLF90)

 dnl Output library status
 AC_MSG_CHECKING([whether to use the XMLF90 library])
 AC_MSG_RESULT([${enable_xmlf90}])

 dnl Determine what to do
 if test "${enable_xmlf90}" = "yes"; then
  AC_DEFINE([HAVE_XMLF90],1,[Define to 1 if you want to use the XMLF90 bindings])

  if test "${with_xmlf90_include}" = "" -o "${with_xmlf90_ldflags}" = "" -o           "${enable_extlibs}" = "no"; then
   xmlf90_include="-I\$(top_builddir)/lib/xmlf90"
   xmlf90_ldflags="-L\$(top_builddir)/lib/xmlf90 -lxmlf90"
   build_xmlf90="yes"

   if test "${enable_tricks}" = "yes"; then
    ABI_TRICKS_XMLF90()
    if test "${xmlf90_tricks_bypass}" = "yes"; then
     build_xmlf90="no"
    fi
   fi
  else
   xmlf90_include="${with_xmlf90_include}"
   xmlf90_ldflags="${with_xmlf90_ldflags}"
   build_xmlf90="no"
  fi
 else
  build_xmlf90="no"
 fi

 dnl Output result
 AC_MSG_CHECKING([whether to build the XMLF90 library])
 AC_MSG_RESULT([${build_xmlf90}])

 dnl Substitute variables needed for the use of the library
 AC_SUBST(xmlf90_include)
 AC_SUBST(xmlf90_ldflags)
 AC_SUBST(build_xmlf90)

 dnl Inform Automake
 AM_CONDITIONAL(DO_BUILD_XMLF90,test "${build_xmlf90}" = "yes")
 AM_CONDITIONAL(DO_ENABLE_XMLF90,test "${enable_xmlf90}" = "yes")
]) # ABI_EXTLIB_XMLF90
