#*****************************************************************************
#                                                                            *
#       Author : J.Jansen                                                    *
#       Version : 2.1                                                        *
#       Date : 6 March 2006                                                  *
#       Purpose : Abinit make file for OpenVMS                               *
#                                                                            *
#*****************************************************************************
#

MAINS=aim,anaddb,cut3d,mrgddb,newsp,lwf,conducti

# Archives for Src* directories
AR_DRIVE=[.src.11drive]lib11drive.olb
AR_CUT3D=[.src.09cut3d]lib09cut3d.olb
AR_SEQ=[.src.08seqpar]lib08abinis.olb
AR_PAR=[.src.08seqpar]lib08abinip.olb
AR_DDB=[.src.07ddb]lib07ddb.olb
AR_LWF=[.src.07lwf]lib07lwf.olb
AR_SUSCEP=[.src.07suscep]lib07suscep.olb
AR_RESPONSE=[.src.06response]lib06response.olb
AR_COMMON=[.src.05common]lib05common.olb
AR_IOWFDENPOT=[.src.04iowfdenpot]lib04iowfdenpot.olb
AR_WFS=[.src.04wfs]lib04wfs.olb
AR_GW=[.src.05gw]lib05gw.olb
AR_IOVARS=[.src.03iovars]lib03iovars.olb
AR_IONETCDF=[.src.03ionetcdf]lib03ionetcdf.olb
AR_PAW=[.src.03paw]lib03paw.olb
AR_RECIPSPACE=[.src.03recipspace]lib03recipspace.olb
AR_XC=[.src.03xc]lib03xc.olb
AR_XML=[.src.03xml]lib03xml.olb
AR_BADER=[.src.04bader]lib04bader.olb
AR_NONLOCAL=[.src.03nonlocal]lib03nonlocal.olb
AR_FFTS=[.src.02ffts]lib02ffts.olb
AR_PSP=[.src.02psp]lib02psp.olb
AR_GEOMETRY=[.src.02geometry]lib02geometry.olb
AR_PARSER=[.src.02parser]lib02parser.olb
AR_SPACEPAR=[.src.02spacepar]lib02spacepar.olb
AR_MGMPI=[.src.01managempi]lib01managempi.olb
AR_CONTRACT=[.src.01contract]lib01contract.olb
AR_UTIL=[.src.01util]lib01util.olb
AR_BASIS=[.src.00basis]lib00basis.olb
AR_BASIP=[.src.00basis]lib00basip.olb
AR_DEFS=[.src.defs]libdefs.olb
AR_GEOMOPTIM=[.src.06geomoptim]lib06geomoptim.olb
AR_OCCEIG=[.src.04occeig]lib04occeig.olb
AR_NLSTRAIN=[.src.02nlstrain]lib02nlstrain.olb

AR_NUMERIC=[.lib.numeric]libnumeric.olb
AR_NUMERICF90=[.lib.numericf90]libnumericf90.olb
AR_FFTNEW=[.src.lib01fftnew]liblib01fftnew.olb

allseq : version,crea_descrip_mms.exe,vms_prepare_input.exe,prepare_input
	$(MMS) numeric,abinis,$(MAINS)

# Create a one-line version definition
version : [.src.defs]defs_infos.F90
	@ write sys$output "version file created"

[.src.defs]defs_infos.F90 : [.src.defs]defs_infos.F90_vms
	copy [.src.defs]defs_infos.F90_vms [.src.defs]defs_infos.F90

crea_descrip_mms.exe : crea_descrip_mms.obj
	link crea_descrip_mms

crea_descrip_mms.obj : [.vms]crea_descrip_mms.f90
	cc/define=(VMS)/comment=as_is/prep=[.vms]crea_descrip_mms.f_\
	[.vms]crea_descrip_mms.f90
	f90/source=free/convert=big_endian/name=lowercase\
	/opti=(tune=host,nopipe)/arch=host/debug\
	/check=(noarg,bo,form,fp,noout,over,powe,under)\
	[.vms]crea_descrip_mms.f_
	delete [.vms]crea_descrip_mms.f_;*

vms_prepare_input.exe : vms_prepare_input.obj
	link vms_prepare_input

vms_prepare_input.obj : [.vms]vms_prepare_input.f90
	cc/define=(VMS)/comment=as_is/prep=[.vms]vms_prepare_input.f_\
	[.vms]vms_prepare_input.f90
	f90/source=free/convert=big_endian/name=lowercase\
	/opti=(tune=host,nopipe)/arch=host/debug\
	/check=(noarg,bo,form,fp,noout,over,powe,under)\
	[.vms]vms_prepare_input.f_
	delete [.vms]vms_prepare_input.f_;*

numeric :
	$(MMS) [.lib.numeric]descrip.mms
	set default [.lib.numeric]
	$(MMS)
	set default [--]

[.src.lib01fftnew]liblib01fftnew.olb :
	$(MMS) [.src.lib01fftnew]descrip.mms
	set default [.src.lib01fftnew]
	$(MMS)
	set default [--]

[.lib.numericf90]libnumericf90.olb :
	$(MMS) [.lib.numericf90]descrip.mms
	set default [.lib.numericf90]
	$(MMS)
	set default [--]

DEP_ABINIS=$(AR_DRIVE) $(AR_SEQ) $(AR_SUSCEP) \
 $(AR_RESPONSE) $(AR_COMMON) $(AR_IOWFDENPOT) $(AR_WFS) $(AR_GW)   \
 $(AR_IOVARS) $(AR_IONETCDF) $(AR_PAW) $(AR_RECIPSPACE) $(AR_XC) $(AR_XML) $(AR_NONLOCAL) \
 $(AR_FFTS) $(AR_PSP) $(AR_GEOMETRY) $(AR_PARSER) $(AR_SPACEPAR)         \
 $(AR_UTIL) $(AR_CONTRACT) $(AR_MGMPI) $(AR_BASIS) $(AR_DEFS) $(AR_FFTNEW)\
 $(AR_NUMERIC) $(AR_NUMERICF90) $(AR_GEOMOPTIM) $(AR_OCCEIG) $(AR_NLSTRAIN)

abinis : abinis.exe
	write sys$output " abinis.exe has been made "
	write sys$output " "

abinis.exe : [.src.main]abinis.obj $(DEP_ABINIS)
	write sys$output " abinis.exe will be made "
	write sys$output " "
	open/write optf abinit.opt
	write optf "$(AR_DRIVE)/lib"
	write optf "$(AR_SEQ)/lib"
	write optf "$(AR_SUSCEP)/lib"
	write optf "$(AR_RESPONSE)/lib"
	write optf "$(AR_GEOMOPTIM)/lib"
	write optf "$(AR_COMMON)/lib"
	write optf "$(AR_GW)/lib"
	write optf "$(AR_IOWFDENPOT)/lib"
	write optf "$(AR_WFS)/lib"
	write optf "$(AR_OCCEIG)/lib"
	write optf "$(AR_IOVARS)/lib"
	write optf "$(AR_IONETCDF)/lib"
	write optf "$(AR_PAW)/lib"
	write optf "$(AR_RECIPSPACE)/lib"
	write optf "$(AR_XC)/lib"
	write optf "$(AR_XML)/lib"
	write optf "$(AR_NONLOCAL)/lib"
	write optf "$(AR_FFTS)/lib"
	write optf "$(AR_PSP)/lib"
	write optf "$(AR_NLSTRAIN)/lib"
	write optf "$(AR_GEOMETRY)/lib"
	write optf "$(AR_PARSER)/lib"
	write optf "$(AR_SPACEPAR)/lib"
	write optf "$(AR_UTIL)/lib"
	write optf "$(AR_CONTRACT)/lib"
	write optf "$(AR_MGMPI)/lib"
	write optf "$(AR_FFTNEW)/lib"
	write optf "$(AR_BASIS)/lib"
	write optf "$(AR_DEFS)/lib"
	write optf "$(AR_NUMERIC)/lib"
	write optf "$(AR_NUMERICF90)/lib"
	write optf "sys$library:libnetcdf/lib"
	write optf "sys$library:libxmlf90/lib"
	close optf
	link/exec=abinis.exe [.src.main]abinis.obj,[]abinit.opt/opt

[.src.main]abinis.obj : [.src.main]abinit.F90 [.src.defs]libdefs.olb
	set default [.src.main]
	cc/define=(VMS,HAVE_NETCDF,HAVE_XMLF90)/comment=as_is/prep=abinit.f_ abinit.F90
	f90/source=free/convert=big_endian/name=lowercase\
	/opti=(tune=host,nopipe)/arch=host/debug/object=abinis.obj\
	/check=(noarg,bo,form,fp,noout,over,powe,under)\
	/include=([--],[--.src.defs]) abinit.f_
	delete abinit.f_;*
	set default [--]

DEP_AIM= $(AR_BADER) $(AR_GEOMETRY) $(AR_IOWFDENPOT) $(AR_UTIL) $(AR_BASIS)\
	$(AR_DEFS) $(AR_MGMPI) $(AR_NUMERIC) $(AR_PARSER) $(AR_NUMERICF90)\
	$(AR_UTIL)

DEP_AIM_LIB=$(AR_BADER)/lib,$(AR_GEOMETRY)/lib,$(AR_IOWFDENPOT)/lib,\
	$(AR_PARSER)/lib,$(AR_UTIL)/lib,$(AR_MGMPI)/lib,$(AR_BASIS)/lib,\
	$(AR_DEFS)/lib,$(AR_NUMERIC)/lib,$(AR_NUMERICF90)/lib,$(AR_UTIL)/lib

aim : aim.exe
	write sys$output " aim.exe has been made "
	write sys$output " "

aim.exe : [.src.main]aim.obj $(DEP_AIM)
	write sys$output " aim.exe will be made "
	write sys$output " "
	link/exec=aim.exe [.src.main]aim.obj,$(DEP_AIM_LIB)

[.src.main]aim.obj : [.src.main]aim.F90 [.src.defs]libdefs.olb
	set default [.src.main]
	cc/define=(VMS,HAVE_NETCDF,HAVE_XMLF90)/comment=as_is/prep=aim.f_ aim.F90
	f90/source=free/convert=big_endian/name=lowercase\
	/opti=(tune=host,nopipe)/arch=host/debug/object=aim.obj\
	/check=(noarg,bo,form,fp,noout,over,powe,under)\
	/include=([--],[--.src.defs]) aim.f_
	delete aim.f_;*
	set default [--]

DEP_ANADDB=$(AR_DDB) $(AR_RESPONSE) $(AR_WFS) $(AR_COMMON) $(AR_IOWFDENPOT)\
 $(AR_RECIPSPACE) $(AR_GEOMETRY) $(AR_NONLOCAL) $(AR_PARSER) $(AR_SPACEPAR) \
 $(AR_UTIL) $(AR_MGMPI) $(AR_BASIS) $(AR_DEFS) $(AR_NUMERIC) $(AR_NUMERICF90) \
 $(AR_UTIL) $(AR_OCCEIG)

DEP_ANADDB_LIB=$(AR_DDB)/lib,$(AR_RESPONSE)/lib,$(AR_WFS)/lib,\
	$(AR_COMMON)/lib,$(AR_IOWFDENPOT)/lib,$(AR_OCCEIG)/lib,\
	$(AR_RECIPSPACE)/lib,\
	$(AR_GEOMETRY)/lib,$(AR_NONLOCAL)/lib,$(AR_PARSER)/lib,\
	$(AR_SPACEPAR)/lib,$(AR_UTIL)/lib,$(AR_MGMPI)/lib,$(AR_BASIS)/lib,\
	$(AR_DEFS)/lib,$(AR_NUMERIC)/lib,$(AR_NUMERICF90)/lib,$(AR_UTIL)/lib

anaddb : anaddb.exe
	write sys$output " anaddb.exe has been made "
	write sys$output " "

anaddb.exe : [.src.main]anaddb.obj $(DEP_ANADDB)
	write sys$output " anaddb.exe will be made "
	write sys$output " "
	link/exec=anaddb.exe [.src.main]anaddb.obj,$(DEP_ANADDB_LIB)

[.src.main]anaddb.obj : [.src.main]anaddb.F90 [.src.defs]libdefs.olb
	set default [.src.main]
	cc/define=(VMS,HAVE_NETCDF,HAVE_XMLF90)/comment=as_is/prep=anaddb.f_ anaddb.F90
	f90/source=free/convert=big_endian/name=lowercase\
	/opti=(tune=host,nopipe)/arch=host/debug/object=anaddb.obj\
	/check=(noarg,bo,form,fp,noout,over,powe,under)\
	/include=([--],[--.src.defs]) anaddb.f_
	delete anaddb.f_;*
	set default [--]

DEP_CUT3D=$(AR_CUT3D) $(AR_SEQ) $(AR_COMMON) $(AR_WFS) $(AR_IOWFDENPOT) \
	$(AR_GEOMETRY) $(AR_FFTS) $(AR_SPACEPAR) $(AR_RECIPSPACE) $(AR_UTIL) \
	$(AR_CONTRACT) $(AR_MGMPI) $(AR_BASIS) $(AR_DEFS) $(AR_FFTNEW)\
	$(AR_NUMERIC) $(AR_NONLOCAL) $(AR_NUMERICF90) $(AR_UTIL)\
	$(AR_OCCEIG) $(AR_PARSER)

DEP_CUT3D_LIB=$(AR_CUT3D)/lib,$(AR_SEQ)/lib,$(AR_COMMON)/lib,$(AR_WFS)/lib,\
	$(AR_IOWFDENPOT)/lib,$(AR_OCCEIG)/lib,$(AR_GEOMETRY)/lib,\
	$(AR_FFTS)/lib,\
	$(AR_SPACEPAR)/lib,$(AR_RECIPSPACE)/lib,$(AR_UTIL)/lib,\
	$(AR_PARSER)/lib,\
	$(AR_NONLOCAL)/lib,$(AR_CONTRACT)/lib,$(AR_MGMPI)/lib,$(AR_BASIS)/lib,\
	$(AR_DEFS)/lib,$(AR_FFTNEW)/lib,$(AR_NUMERIC)/lib,\
	$(AR_NUMERICF90)/lib,$(AR_UTIL)/lib,sys$library:libnetcdf/lib

cut3d : cut3d.exe
	write sys$output " cut3d.exe has been made "
	write sys$output " "

cut3d.exe : [.src.main]cut3d.obj $(DEP_CUT3D)
	write sys$output " cut3d.exe will be made "
	write sys$output " "
	link/exec=cut3d.exe [.src.main]cut3d.obj,$(DEP_CUT3D_LIB)

[.src.main]cut3d.obj : [.src.main]cut3d.F90 [.src.defs]libdefs.olb
	set default [.src.main]
	cc/define=(VMS,HAVE_NETCDF,HAVE_XMLF90)/comment=as_is/prep=cut3d.f_ cut3d.F90
	f90/source=free/convert=big_endian/name=lowercase\
	/opti=(tune=host,nopipe)/arch=host/debug/object=cut3d.obj\
	/check=(noarg,bo,form,fp,noout,over,powe,under)\
	/include=([--],[--.src.defs]) cut3d.f_
	delete cut3d.f_;*
	set default [--]

DEP_MRGDDB=$(AR_DDB) $(AR_RESPONSE) $(AR_UTIL) $(AR_MGMPI) $(AR_BASIS)\
	$(AR_DEFS) $(AR_NUMERIC)

DEP_MRGDDB_LIB=$(AR_DDB)/lib,$(AR_RESPONSE)/lib,$(AR_UTIL)/lib,\
	$(AR_MGMPI)/lib,$(AR_BASIS)/lib,$(AR_DEFS)/lib,$(AR_NUMERIC)/lib

mrgddb : mrgddb.exe
	write sys$output " mrgddb.exe has been made "
	write sys$output " "

mrgddb.exe : [.src.main]mrgddb.obj $(DEP_MRGDDB)
	write sys$output " mrgddb.exe will be made "
	write sys$output " "
	link/exec=mrgddb.exe [.src.main]mrgddb.obj,$(DEP_MRGDDB_LIB)

[.src.main]mrgddb.obj : [.src.main]mrgddb.F90 [.src.defs]libdefs.olb
	set default [.src.main]
	cc/define=(VMS,HAVE_NETCDF,HAVE_XMLF90)/comment=as_is/prep=mrgddb.f_ mrgddb.F90
	f90/source=free/convert=big_endian/name=lowercase\
	/opti=(tune=host,nopipe)/arch=host/debug/object=mrgddb.obj\
	/check=(noarg,bo,form,fp,noout,over,powe,under)\
	/include=([--],[--.src.defs]) mrgddb.f_
	delete mrgddb.f_;*
	set default [--]

DEP_NEWSP=$(AR_SEQ) $(AR_COMMON) $(AR_WFS) $(AR_IOWFDENPOT) $(AR_IOVARS) $(AR_IONETCDF)\
	$(AR_RECIPSPACE) $(AR_XML) $(AR_NONLOCAL)     \
	$(AR_FFTS) $(AR_GEOMETRY) $(AR_PARSER) $(AR_SPACEPAR)         \
	$(AR_UTIL) $(AR_CONTRACT) $(AR_MGMPI) $(AR_BASIS) $(AR_DEFS)\
	$(AR_FFTNEW) $(AR_NUMERIC) $(AR_NUMERICF90) $(AR_UTIL)

DEP_NEWSP_LIB=$(AR_SEQ)/lib,$(AR_COMMON)/lib,$(AR_WFS)/lib,\
	$(AR_IOWFDENPOT)/lib,$(AR_IOVARS)/lib,$(AR_IONETCDF)/lib,$(AR_RECIPSPACE)/lib,\
	$(AR_XML)/lib,$(AR_NONLOCAL)/lib,$(AR_FFTS)/lib,$(AR_GEOMETRY)/lib,\
	$(AR_PARSER)/lib,$(AR_SPACEPAR)/lib,$(AR_UTIL)/lib,$(AR_CONTRACT)/lib,\
	$(AR_MGMPI)/lib,$(AR_BASIS)/lib,$(AR_DEFS)/lib,$(AR_FFTNEW)/lib,\
	$(AR_NUMERIC)/lib,$(AR_NUMERICF90)/lib,$(AR_UTIL)/lib,\
	sys$library:libnetcdf/lib

newsp : newsp.exe
	write sys$output " newsp.exe has been made "
	write sys$output " "

newsp.exe : [.src.main]newsp.obj $(DEP_NEWSP)
	write sys$output " newsp.exe will be made "
	write sys$output " "
	link/exec=newsp.exe [.src.main]newsp.obj,$(DEP_NEWSP_LIB)

[.src.main]newsp.obj : [.src.main]newsp.F90 [.src.defs]libdefs.olb
	set default [.src.main]
	cc/define=(VMS,HAVE_NETCDF,HAVE_XMLF90)/comment=as_is/prep=newsp.f_ newsp.F90
	f90/source=free/convert=big_endian/name=lowercase\
	/opti=(tune=host,nopipe)/arch=host/debug/object=newsp.obj\
	/check=(noarg,bo,form,fp,noout,over,powe,under)\
	/include=([--],[--.src.defs]) newsp.f_
	delete newsp.f_;*
	set default [--]

DEP_LWF=$(AR_LWF) $(AR_PARSER) $(AR_UTIL) $(AR_MGMPI) $(AR_BASIS) $(AR_DEFS)\
	$(AR_NUMERIC)

DEP_LWF_LIB=$(AR_LWF)/lib,$(AR_PARSER)/lib,$(AR_UTIL)/lib,$(AR_MGMPI)/lib,\
	$(AR_BASIS)/lib,$(AR_DEFS)/lib,$(AR_NUMERIC)/lib

lwf : lwf.exe
	write sys$output " lwf.exe has been made "
	write sys$output " "

lwf.exe : [.src.main]lwf.obj $(DEP_LWF)
	write sys$output " lwf.exe will be made "
	write sys$output " "
	link/exec=lwf.exe [.src.main]lwf.obj,$(DEP_LWF_LIB)

[.src.main]lwf.obj : [.src.main]lwf.F90 [.src.defs]libdefs.olb
	set default [.src.main]
	cc/define=(VMS,HAVE_NETCDF,HAVE_XMLF90)/comment=as_is/prep=lwf.f_ lwf.F90
	f90/source=free/convert=big_endian/name=lowercase\
	/opti=(tune=host,nopipe)/arch=host/debug/object=lwf.obj\
	/check=(noarg,bo,form,fp,noout,over,powe,under)\
	/include=([--],[--.src.defs]) lwf.f_
	delete lwf.f_;*
	set default [--]

DEP_CONDUCTI=$(AR_COMMON) $(AR_IOWFDENPOT) $(AR_GEOMETRY) $(AR_UTIL)\
	$(AR_MGMPI) $(AR_BASIS) $(AR_DEFS) $(AR_NUMERIC) $(AR_NUMERICF90)\
	$(AR_UTIL) $(AR_OCCEIG)

DEP_CONDUCTI_LIB=$(AR_COMMON)/lib,$(AR_IOWFDENPOT)/lib,$(AR_OCCEIG)/lib,\
	$(AR_GEOMETRY)/lib,\
	$(AR_UTIL)/lib,$(AR_MGMPI)/lib,$(AR_BASIS)/lib,$(AR_DEFS)/lib,\
	$(AR_NUMERIC)/lib,$(AR_NUMERICF90)/lib,$(AR_UTIL)/lib,\
	sys$library:libnetcdf/lib

conducti : conducti.exe
	write sys$output " conducti.exe has been made "
	write sys$output " "

conducti.exe : [.src.main]conducti.obj $(DEP_CONDUCTI)
	write sys$output " conducti.exe will be made "
	write sys$output " "
	link/exec=conducti.exe [.src.main]conducti.obj,$(DEP_CONDUCTI_LIB)

[.src.main]conducti.obj : [.src.main]conducti.F90 [.src.defs]libdefs.olb
	set default [.src.main]
	cc/define=(VMS,HAVE_NETCDF,HAVE_XMLF90)/comment=as_is/prep=conducti.f_ conducti.F90
	f90/source=free/convert=big_endian/name=lowercase\
	/opti=(tune=host,nopipe)/arch=host/debug/object=conducti.obj\
	/check=(noarg,bo,form,fp,noout,over,powe,under)\
	/include=([--],[--.src.defs]) conducti.f_
	delete conducti.f_;*
	set default [--]

[.src.defs]libdefs.olb :
	$(MMS) [.src.defs]descrip.mms
	set default [.src.defs]
	$(MMS) m_pseudo_types.obj
	$(MMS)
	set default [--]

[.src.11drive]lib11drive.olb :
	$(MMS) [.src.11drive]descrip.mms
	set default [.src.11drive]
	$(MMS)
	set default [--]

[.src.06geomoptim]lib06geomoptim.olb :
	$(MMS) [.src.06geomoptim]descrip.mms
	set default [.src.06geomoptim]
	$(MMS)
	set default [--]

[.src.04occeig]lib04occeig.olb :
	$(MMS) [.src.04occeig]descrip.mms
	set default [.src.04occeig]
	$(MMS)
	set default [--]

[.src.02nlstrain]lib02nlstrain.olb :
	$(MMS) [.src.02nlstrain]descrip.mms
	set default [.src.02nlstrain]
	$(MMS)
	set default [--]

[.src.09cut3d]lib09cut3d.olb :
	$(MMS) [.src.09cut3d]descrip.mms
	set default [.src.09cut3d]
	$(MMS)
	set default [--]

[.src.08seqpar]lib08abinis.olb :
	$(MMS) [.src.08seqpar]descrip.mms
	set default [.src.08seqpar]
	$(MMS)
	copy lib08seqpar.olb lib08abinis.olb
	set default [--]

[.src.07suscep]lib07suscep.olb :
	$(MMS) [.src.07suscep]descrip.mms
	set default [.src.07suscep]
	$(MMS)
	set default [--]

[.src.07ddb]lib07ddb.olb :
	$(MMS) [.src.07ddb]descrip.mms
	set default [.src.07ddb]
	$(MMS)
	set default [--]

[.src.07lwf]lib07lwf.olb :
	$(MMS) [.src.07lwf]descrip.mms
	set default [.src.07lwf]
	$(MMS)
	set default [--]

[.src.06response]lib06response.olb :
	$(MMS) [.src.06response]descrip.mms
	set default [.src.06response]
	$(MMS)
	set default [--]

[.src.05common]lib05common.olb :
	$(MMS) [.src.05common]descrip.mms
	set default [.src.05common]
	$(MMS)
	set default [--]

[.src.04iowfdenpot]lib04iowfdenpot.olb :
	$(MMS) [.src.04iowfdenpot]descrip.mms
	set default [.src.04iowfdenpot]
	$(MMS)
	set default [--]

[.src.04wfs]lib04wfs.olb :
	$(MMS) [.src.04wfs]descrip.mms
	set default [.src.04wfs]
	$(MMS)
	set default [--]

[.src.05gw]lib05gw.olb :
	$(MMS) [.src.05gw]descrip.mms
	set default [.src.05gw]
	$(MMS)
	set default [--]

[.src.03iovars]lib03iovars.olb : [.src.03ionetcdf]def_dtset_ncdf.F90\
	[.src.03ionetcdf]put_dtset_ncdf.F90
	$(MMS) [.src.03iovars]descrip.mms
	set default [.src.03iovars]
	$(MMS)
	set default [--]

[.src.03ionetcdf]def_dtset_ncdf.F90 :\
	[.util.subs.netcdf]make-sub-def_dtset_ncdf.pl\
	[.util.subs.common]abinit_variables.pm
	perl [.util.subs.netcdf]make-sub-def_dtset_ncdf.pl

[.src.03ionetcdf]put_dtset_ncdf.F90 :\
	[.util.subs.netcdf]make-sub-put_dtset_ncdf.pl\
	[.util.subs.common]abinit_variables.pm
	perl [.util.subs.netcdf]make-sub-put_dtset_ncdf.pl

[.src.03ionetcdf]lib03ionetcdf.olb :
	$(MMS) [.src.03ionetcdf]descrip.mms
	set default [.src.03ionetcdf]
	$(MMS)
	set default [--]

[.src.03paw]lib03paw.olb :
	$(MMS) [.src.03paw]descrip.mms
	set default [.src.03paw]
	$(MMS)
	set default [--]

[.src.03recipspace]lib03recipspace.olb :
	$(MMS) [.src.03recipspace]descrip.mms
	set default [.src.03recipspace]
	$(MMS)
	set default [--]

[.src.03xc]lib03xc.olb :
	$(MMS) [.src.03xc]descrip.mms
	set default [.src.03xc]
	$(MMS)
	set default [--]

[.src.03xml]lib03xml.olb :
	$(MMS) [.src.03xml]descrip.mms
	set default [.src.03xml]
	$(MMS)
	set default [--]

[.src.03nonlocal]lib03nonlocal.olb :
	$(MMS) [.src.03nonlocal]descrip.mms
	set default [.src.03nonlocal]
	$(MMS)
	set default [--]

[.src.02ffts]lib02ffts.olb :
	$(MMS) [.src.02ffts]descrip.mms
	set default [.src.02ffts]
	$(MMS)
	set default [--]

[.src.02psp]lib02psp.olb :
	$(MMS) [.src.02psp]descrip.mms
	set default [.src.02psp]
	$(MMS) smoothvlocal.obj
	$(MMS)
	set default [--]

[.src.02geometry]lib02geometry.olb :
	$(MMS) [.src.02geometry]descrip.mms
	set default [.src.02geometry]
	$(MMS)
	set default [--]

[.src.02parser]lib02parser.olb :
	$(MMS) [.src.02parser]descrip.mms
	set default [.src.02parser]
	$(MMS)
	set default [--]

[.src.02spacepar]lib02spacepar.olb :
	$(MMS) [.src.02spacepar]descrip.mms
	set default [.src.02spacepar]
	$(MMS)
	set default [--]

[.src.04bader]lib04bader.olb :
	$(MMS) [.src.04bader]descrip.mms
	set default [.src.04bader]
	$(MMS)
	set default [--]

[.src.01contract]lib01contract.olb :
	$(MMS) [.src.01contract]descrip.mms
	set default [.src.01contract]
	$(MMS)
	set default [--]

[.src.01managempi]lib01managempi.olb :
	$(MMS) [.src.01managempi]descrip.mms
	set default [.src.01managempi]
	$(MMS)
	set default [--]

[.src.01util]lib01util.olb :
	$(MMS) [.src.01util]descrip.mms
	set default [.src.01util]
	$(MMS)
	set default [--]

[.src.00basis]lib00basis.olb :
	$(MMS) [.src.00basis]descrip.mms
	set default [.src.00basis]
	$(MMS)
	set default [--]

[.src.lib01fftnew]descrip.mms : crea_descrip_mms.exe
	set def [.src.lib01fftnew]
	run [--]crea_descrip_mms
	set def [--]

[.lib.numeric]descrip.mms : crea_descrip_mms.exe
	set def [.lib.numeric]
	run [--]crea_descrip_mms
	set def [--]

[.lib.numericf90]descrip.mms : crea_descrip_mms.exe
	set def [.lib.numericf90]
	run [--]crea_descrip_mms
	set def [--]

[.src.00basis]descrip.mms : crea_descrip_mms.exe
	set def [.src.00basis]
	run [--]crea_descrip_mms
	set def [--]

[.src.01managempi]descrip.mms : crea_descrip_mms.exe
	set def [.src.01managempi]
	run [--]crea_descrip_mms
	set def [--]

[.src.01contract]descrip.mms : crea_descrip_mms.exe
	set def [.src.01contract]
	run [--]crea_descrip_mms
	set def [--]

[.src.01util]descrip.mms : crea_descrip_mms.exe
	set def [.src.01util]
	run [--]crea_descrip_mms
	set def [--]

[.src.04bader]descrip.mms : crea_descrip_mms.exe
	set def [.src.04bader]
	run [--]crea_descrip_mms
	set def [--]

[.src.02ffts]descrip.mms : crea_descrip_mms.exe
	set def [.src.02ffts]
	run [--]crea_descrip_mms
	set def [--]

[.src.02geometry]descrip.mms : crea_descrip_mms.exe
	set def [.src.02geometry]
	run [--]crea_descrip_mms
	set def [--]

[.src.03nonlocal]descrip.mms : crea_descrip_mms.exe
	set def [.src.03nonlocal]
	run [--]crea_descrip_mms
	set def [--]

[.src.02parser]descrip.mms : crea_descrip_mms.exe
	set def [.src.02parser]
	run [--]crea_descrip_mms
	set def [--]

[.src.02psp]descrip.mms : crea_descrip_mms.exe
	set def [.src.02psp]
	run [--]crea_descrip_mms
	set def [--]

[.src.02spacepar]descrip.mms : crea_descrip_mms.exe
	set def [.src.02spacepar]
	run [--]crea_descrip_mms
	set def [--]

[.src.05gw]descrip.mms : crea_descrip_mms.exe
	set def [.src.05gw]
	run [--]crea_descrip_mms
	set def [--]

[.src.03iovars]descrip.mms : crea_descrip_mms.exe
	set def [.src.03iovars]
	run [--]crea_descrip_mms
	set def [--]

[.src.03ionetcdf]descrip.mms : crea_descrip_mms.exe
	set def [.src.03ionetcdf]
	run [--]crea_descrip_mms
	set def [--]

[.src.03paw]descrip.mms : crea_descrip_mms.exe
	set def [.src.03paw]
	run [--]crea_descrip_mms
	set def [--]

[.src.03recipspace]descrip.mms : crea_descrip_mms.exe
	set def [.src.03recipspace]
	run [--]crea_descrip_mms
	set def [--]

[.src.03xc]descrip.mms : crea_descrip_mms.exe
	set def [.src.03xc]
	run [--]crea_descrip_mms
	set def [--]

[.src.03xml]descrip.mms : crea_descrip_mms.exe
	set def [.src.03xml]
	run [--]crea_descrip_mms
	set def [--]

[.src.04iowfdenpot]descrip.mms : crea_descrip_mms.exe
	set def [.src.04iowfdenpot]
	run [--]crea_descrip_mms
	set def [--]

[.src.04wfs]descrip.mms : crea_descrip_mms.exe
	set def [.src.04wfs]
	run [--]crea_descrip_mms
	set def [--]

[.src.05common]descrip.mms : crea_descrip_mms.exe
	set def [.src.05common]
	run [--]crea_descrip_mms
	set def [--]

[.src.06response]descrip.mms : crea_descrip_mms.exe
	set def [.src.06response]
	run [--]crea_descrip_mms
	set def [--]

[.src.07ddb]descrip.mms : crea_descrip_mms.exe
	set def [.src.07ddb]
	run [--]crea_descrip_mms
	set def [--]

[.src.07lwf]descrip.mms : crea_descrip_mms.exe
	set def [.src.07lwf]
	run [--]crea_descrip_mms
	set def [--]

[.src.07suscep]descrip.mms : crea_descrip_mms.exe
	set def [.src.07suscep]
	run [--]crea_descrip_mms
	set def [--]

[.src.08seqpar]descrip.mms : crea_descrip_mms.exe
	set def [.src.08seqpar]
	run [--]crea_descrip_mms
	set def [--]

[.src.09cut3d]descrip.mms : crea_descrip_mms.exe
	set def [.src.09cut3d]
	run [--]crea_descrip_mms
	set def [--]

[.src.11drive]descrip.mms : crea_descrip_mms.exe
	set def [.src.11drive]
	run [--]crea_descrip_mms
	set def [--]

[.src.02nlstrain]descrip.mms : crea_descrip_mms.exe
	set def [.src.02nlstrain]
	run [--]crea_descrip_mms
	set def [--]

[.src.06geomoptim]descrip.mms : crea_descrip_mms.exe
	set def [.src.06geomoptim]
	run [--]crea_descrip_mms
	set def [--]

[.src.04occeig]descrip.mms : crea_descrip_mms.exe
	set def [.src.04occeig]
	run [--]crea_descrip_mms
	set def [--]

[.src.defs]descrip.mms : crea_descrip_mms.exe
	set def [.src.defs]
	run [--]crea_descrip_mms
	set def [--]

prepare_input :
	set def [.tests.tutorial.Input]
	mcr [---]vms_prepare_input t1x.files
	mcr [---]vms_prepare_input t2x.files
	mcr [---]vms_prepare_input t3x.files
	mcr [---]vms_prepare_input t4x.files
	set def [---]

# Build-in tests
tests : test1 test2 test3 test4 test5 test6
	write sys$output "Performed test 1-6"

test12 : test1 test2 
	write sys$output "Performed test 1-2"

test123 : test1 test2 test3 
	write sys$output "Performed test 1-3"

test124 : test1 test2 test4 
	write sys$output "Performed test 1,2,4"

test125 : test1 test2 test5 
	write sys$output "Performed test 1,2,5"

test1 :
	@ @[.tests.Scripts]run-basic-tests.com [.tests.built-in] 1

test2 :
	@ @[.tests.Scripts]run-basic-tests.com [.tests.built-in] 2

test3 :
	@ @[.tests.Scripts]run-basic-tests.com [.tests.built-in] 3

test4 :
	@ @[.tests.Scripts]run-basic-tests.com [.tests.built-in] 4

test5 :
	@ @[.tests.Scripts]run-basic-tests.com [.tests.built-in] 5

test6 :
	@ @[.tests.Scripts]run-basic-tests.com [.tests.xmlf90] 6
