!{\src2tex{textfont=tt}}
!!****f* ABINIT/netcdf_file_close
!! NAME
!! netcdf_file_close
!!
!! FUNCTION
!!  Creates a NetCDF file and prepares it to store specified data.
!!
!! COPYRIGHT
!!  Copyright (C) 2005-2006 ABINIT group (Y. Pouillon)
!!  This file is distributed under the terms of the
!!  GNU General Public License, see ~abinit/COPYING
!!  or http://www.gnu.org/copyleft/gpl.txt .
!!  For the initials of contributors, see ~abinit/doc/developers/contributors .
!!
!! INPUTS
!!  ncid = NetCDF identifier of the file to close
!!
!! OUTPUT
!!  (no direct output : data written to a NetCDF file)
!!
!! PARENTS
!!      xcacfd
!!
!! CHILDREN
!!      netcdf_def_acfd,netcdf_def_den,netcdf_def_dtset,netcdf_def_wfs,netcdf_handle_error
!!      leave_new,wrtout
!!
!! SOURCE

#if defined HAVE_CONFIG_H
#include "config.h"
#endif

subroutine netcdf_file_close(ncid)

 use defs_basis
#if defined HAVE_NETCDF
 use netcdf
#endif

!This section has been created automatically by the script Abilint (TD). Do not modify these by hand.
#ifdef HAVE_FORTRAN_INTERFACES
 use interfaces_01managempi
 use interfaces_03ionetcdf, except_this_one => netcdf_file_close
#endif
!End of the abilint section

 implicit none

!Arguments ------------------------------------
!scalars
 integer,intent(in) :: ncid

!Local variables-------------------------------
!scalars
 integer :: ncerr
 character(len=500) :: message

! ***************************************************************************

#if defined HAVE_NETCDF
 ncerr = nf90_close(ncid)
 call netcdf_handle_error('I/O','END','closing file','netcdf_file_close',ncerr)
#else
 write(message,'(4a)') ch10,' netcdf_file_close - ERROR',ch10,&
&  'This version has not been compiled with NetCDF support'
 call wrtout(std_out,message,'COLL')
 call leave_new('COLL')
#endif

end subroutine netcdf_file_close
!!***
