!{\src2tex{textfont=tt}}
!!****f* ABINIT/prep_coh
!! NAME
!! prep_coh
!!
!! FUNCTION
!!
!! COPYRIGHT
!! Copyright (C) 2005-2006 ABINIT group (FB)
!! This file is distributed under the terms of the
!! GNU General Public License, see ~abinit/COPYING
!! or http://www.gnu.org/copyleft/gpl.txt .
!!
!! INPUTS
!!  (to be filled)
!!
!! OUTPUT
!!  (to be filled)
!!
!! SIDE EFFECTS
!!
!! NOTES
!!
!! PARENTS
!!      csigme
!!
!! CHILDREN
!!      fourdp
!!
!! SOURCE

#if defined HAVE_CONFIG_H
#include "config.h"
#endif

subroutine prep_coh(nb,nr,wfr_k,ktabr_k,minbnd,maxbnd,ngfft1,ngfft2,ngfft3,tim_fourdp,wfg2,mpi_enreg)

 use defs_basis
 use defs_datatypes

!This section has been created automatically by the script Abilint (TD). Do not modify these by hand.
#ifdef HAVE_FORTRAN_INTERFACES
 use interfaces_02ffts
#endif
!End of the abilint section

 implicit none

!Arguments ------------------------------------
!scalars
 integer,intent(in) :: maxbnd,minbnd,nb,ngfft1,ngfft2,ngfft3,nr,tim_fourdp
 type(MPI_type),intent(inout) :: mpi_enreg
!arrays
 integer,intent(in) :: ktabr_k(nr)
 complex,intent(in) :: wfr_k(nr,nb)
 complex,intent(out) :: wfg2(nr,minbnd:maxbnd,minbnd:maxbnd)

!Local variables-------------------------------
!scalars
 integer :: jb,kb
!arrays
 integer :: ngfft(18)
 real(dp) :: wfg2_tmp(2,nr),wfr2_tmp(2,nr)

! *************************************************************************

!DEBUG
!write(6,*)' prep_coh : enter '
!ENDDEBUG

 do jb=minbnd,maxbnd
  do kb=minbnd,maxbnd

   wfr2_tmp(1,:)=real(wfr_k(ktabr_k(:),jb))*real(wfr_k(ktabr_k(:),kb))&
&               +aimag(wfr_k(ktabr_k(:),jb))*aimag(wfr_k(ktabr_k(:),kb))
   wfr2_tmp(2,:)=real(wfr_k(ktabr_k(:),jb))*aimag(wfr_k(ktabr_k(:),kb))&
&               -real(wfr_k(ktabr_k(:),kb))*aimag(wfr_k(ktabr_k(:),jb))

   ngfft(1)=ngfft1
   ngfft(2)=ngfft2
   ngfft(3)=ngfft3
   ngfft(4)=2*(ngfft(1)/2)+1
   ngfft(5)=2*(ngfft(2)/2)+1
   ngfft(6)=ngfft(3)
   ngfft(7)=200
   ngfft(8)=256
   ngfft(9)=0
   ngfft(10)=1
   ngfft(11)=0
   ngfft(12)=ngfft2
   ngfft(13)=ngfft3
   ngfft(14)=0
   call fourdp(2,wfg2_tmp,wfr2_tmp,-1,mpi_enreg,nr,ngfft,tim_fourdp)
   wfg2(:,jb,kb)=wfg2_tmp(1,:)+(0.,1.)*wfg2_tmp(2,:)

  end do
 end do


end subroutine prep_coh
!!***
