!{\src2tex{textfont=tt}}
!!****f* ABINIT/setup_hamilt
!! NAME
!! setup_hamilt
!!
!! FUNCTION
!!  N/D [FIXME]
!!
!! COPYRIGHT
!!  Copyright (C) 2005-2006 ABINIT group (FBruneval)
!!  This file is distributed under the terms of the
!!  GNU General Public License, see ~abinit/COPYING
!!  or http://www.gnu.org/copyleft/gpl.txt .
!!
!! INPUTS
!!  argin(sizein)=description
!!
!! OUTPUT
!!  argout(sizeout)=description
!!
!! SIDE EFFECTS
!!
!! NOTES
!!
!! PARENTS
!!      sigma
!!
!! CHILDREN
!!      zheev
!!
!! SOURCE
!FBruneval 040928
!

#if defined HAVE_CONFIG_H
#include "config.h"
#endif

subroutine hartrham(dtset,sp,gmet,ucvol,ngfft1,ngfft2,ngfft3,nfft,&
& npwvec,gvec,kibz,wtk,wfr,wfg,rho,occ,en,hhartr,mpi_enreg)

 use defs_basis
 use defs_datatypes

!This section has been created automatically by the script Abilint (TD). Do not modify these by hand.
#ifdef HAVE_FORTRAN_INTERFACES
 use interfaces_02ffts
 use interfaces_03xc
#endif
!End of the abilint section

 implicit none

!Arguments ------------------------------------
!scalars
 integer,intent(in) :: nfft,ngfft1,ngfft2,ngfft3,npwvec
 real(dp),intent(in) :: ucvol
 type(MPI_type),intent(inout) :: mpi_enreg
 type(dataset_type) :: dtset
 type(sigma_parameters) :: sp
!arrays
 integer,intent(in) :: gvec(3,npwvec)
 real(dp),intent(in) :: en(sp%nk,sp%nb),gmet(3,3),kibz(3,sp%nk)
 real(dp),intent(in) :: occ(sp%nk,sp%nb),wtk(sp%nk)
 real(dp),intent(inout) :: rho(nfft)
 complex,intent(in) :: wfg(sp%npwwfn,sp%nb,sp%nk),wfr(nfft,sp%nb,sp%nk)
 complex,intent(out) :: hhartr(sp%nb,sp%nb,sp%nk)

!Local variables -------------------------
!scalars
 integer :: ib,ib1,ib2,ig,ig1,ig2,ig3,ik,ir,ir1,ir2,ir3,nb
 real(dp) :: eband,ecut,ehartr,ekin,g1,g2,g3,gsq,gsqcut,rtmp
 complex :: ctmp,ctmp1,ctmp2
!arrays
 integer :: ngfft(18)
 real(dp) :: at(3),kinpw(npwvec),qphon(3),rhog(2,nfft),vhartr(nfft)

! *********************************************************************

 ! Next line added by YP
 ngfft(:)=0
 ngfft(1)=ngfft1
 ngfft(2)=ngfft2
 ngfft(3)=ngfft3
 ngfft(4)=2*(ngfft(1)/2)+1
 ngfft(5)=2*(ngfft(2)/2)+1
 ngfft(6)=ngfft(3)
 ngfft(7)=200
 ngfft(8)=256
 ngfft(9)=0
 ngfft(10)=1
 ngfft(11)=0
 ngfft(12)=ngfft2
 ngfft(13)=ngfft3
 ngfft(14)=0
 gsqcut=-1.0
 do ig=1,npwvec
  g1=real(gvec(1,ig))
  g2=real(gvec(2,ig))
  g3=real(gvec(3,ig))
  gsq=gmet(1,1)*g1**2+gmet(2,2)*g2**2+gmet(3,3)*g3**2+ &
&                2.0*(gmet(1,2)*g1*g2+gmet(1,3)*g1*g3+gmet(2,3)*g2*g3)
  gsqcut=max(gsqcut,gsq)
 end do

 call fourdp(1,rhog,rho,-1,mpi_enreg,nfft,ngfft,4)

!DEBUG
! write(*,*) '*** number of electrons *** ',rhog(1,1)*ucvol
!ENDDEBUG

!band energy
 eband=0
 do ik=1,sp%nk
  do ib=1,sp%nb
   eband=eband+wtk(ik)/sum(wtk(:))*en(ik,ib)*occ(ik,ib)
  end do
 end do
 write(*,*) '*** Band Energy  ***',eband

! XG060206 SOMETHING WRONG HERE : npwvec might be larger than sp%npwwfn
! hence, the dot_product will bring garbage in ekin
!kinetic potential and energy
! ecut=1.d100  ! dtset%ecutwfn !  15. !  2.*acos(-1.)**2*gsqcut
! ekin=0
! do ik=1,sp%nk
!!caution gvec and kinpw sorted by G shells
!  call mkkin(ecut,dtset%ecutsm,dtset%effmass,gmet,gvec,kinpw,kibz(:,ik),npwvec)
!  do ib=1,sp%nb
!   ekin=ekin+wtk(ik)/sum(wtk(:))*occ(ik,ib)&
!&   *dot_product(wfg(1:npwvec,ib,ik),kinpw(1:npwvec)*wfg(1:npwvec,ib,ik))
!  end do
! end do
! write(*,*) '*** Kinetic Energy ***',ekin

!hartree potential and energy
 qphon(:)=0.d0
 call hartre(1,gmet,gsqcut,0,mpi_enreg,nfft,ngfft,qphon,rhog,vhartr)
 write(*,*) '*** Hartree Energy *** ',0.5*ucvol/nfft*sum( rho(:)*vhartr(:) )


 do ik=1,sp%nk
  do ib2=1,sp%nb
   do ib1=1,sp%nb
    hhartr(ib1,ib2,ik)=sum(vhartr(:)*conjg(wfr(:,ib1,ik))*wfr(:,ib2,ik))/nfft
   end do
  end do
 end do

!DEBUG
!!check hartree energy a second time
! ehartr=0
! do ik=1,sp%nk
!  do ib1=1,sp%nb
!   ehartr=ehartr+0.5*wtk(ik)/sum(wtk(:))*hhartr(ib1,ib1,ik)*occ(ik,ib1)
!  end do
! end do
! write(*,*) 'hartree2',ehartr
!ENDDEBUG

end subroutine hartrham

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

subroutine ham_changebasis(nb,nk,c,h)
 use defs_basis

 implicit none

integer,intent(in) :: nb,nk
 complex,intent(in) :: c(nb,nb,nk)
 complex,intent(inout) :: h(nb,nb,nk)
!local variables
 integer :: ik,ib1,ib2,ib3,ib4
 complex :: ctmp(nb,nb)
 complex :: htmp(nb,nb,nk)

 htmp(:,:,:)=h(:,:,:)
 h(:,:,:)=0

 do ik=1,nk
!  do ib4=1,nb
!   do ib3=1,nb
!    do ib2=1,nb
!     do ib1=1,nb
!      h(ib3,ib4,ik)=h(ib3,ib4,ik)+conjg(c(ib1,ib3,ik))*c(ib2,ib4,ik)*htmp(ib1,ib2,ik)
!     end do
!    end do
!   end do
!  end do
  ctmp(:,:)=matmul(htmp(:,:,ik),c(:,:,ik))
  h(:,:,ik)=matmul(conjg(transpose(c(:,:,ik))),ctmp(:,:))
 end do

end subroutine ham_changebasis

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

function numtochar(un)

 implicit none

!Arguments -------------------------------
 character(len=4) :: numtochar
 integer :: un

!Local variables -------------------------
 integer :: i(4)

 i(1)=un/1000
 i(2)=(un-1000*i(1))/100
 i(3)=(un-1000*i(1)-100*i(2))/10
 i(4)=un-1000*i(1)-100*i(2)-10*i(3)

 numtochar=achar(i(1)+48)//achar(i(2)+48)//achar(i(3)+48)//achar(i(4)+48)

end function numtochar

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

subroutine diago_hamilt(minbnd,maxbnd,hhartree,sigxme,sigcme,eigvec_qp,en_qp)

 use defs_basis

 implicit none

!in/out
 integer,intent(in) :: minbnd,maxbnd
 complex,intent(in) :: hhartree(minbnd:maxbnd,minbnd:maxbnd)
 complex,intent(in) :: sigxme(minbnd:maxbnd,minbnd:maxbnd)
 complex,intent(in) :: sigcme(minbnd:maxbnd,minbnd:maxbnd)
 complex,intent(inout) :: eigvec_qp(minbnd:maxbnd,minbnd:maxbnd)
 real(dp),intent(out) :: en_qp(minbnd:maxbnd)
!local
 integer :: ib,nmatrix
 complex :: htotal(minbnd:maxbnd,minbnd:maxbnd)
 integer :: lwork,info
 complex(dp),allocatable :: hdp(:,:),work(:)
 real(dp),allocatable :: eig(:),rwork(:)

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

#ifdef VMS
!DEC$ ATTRIBUTES ALIAS:'ZHEEV' :: zheev
#endif

#ifdef __VMS
!DEC$ ATTRIBUTES ALIAS:'ZHEEV' :: zheev
#endif

 write(*,*) 'diagonalize the QP Hamiltonian'
!size of the matrix
 nmatrix=maxbnd-minbnd+1

!hermitianize the hamiltonian
 htotal(:,:)=hhartree(:,:)+sigxme(:,:)+sigcme(:,:)
 htotal(:,:)=0.5 * ( htotal(:,:) + conjg(transpose(htotal(:,:))) )

 lwork=2*nmatrix-1
 allocate(hdp(nmatrix,nmatrix),eig(nmatrix),work(lwork),rwork(3*nmatrix-2))
 hdp(:,:)=htotal(minbnd:maxbnd,minbnd:maxbnd)
 call zheev('v','u',nmatrix,hdp,nmatrix,eig,work,lwork,rwork,info)


 eigvec_qp(minbnd:maxbnd,minbnd:maxbnd)=hdp(:,:)
 en_qp(minbnd:maxbnd)=eig(:)

 deallocate(hdp,eig,work,rwork)

!DEBUG
! do ib=minbnd,maxbnd
!  write(*,'(i3,1x,9(f12.5)))') ib,hhartree(ib,ib)*Ha_eV,real(sigxme(ib,ib))*Ha_eV,&
!&  sigcme(ib,ib)*Ha_eV,htotal(ib,ib)*Ha_eV,en_qp(ib)*Ha_eV,abs(eigvec_qp(ib,ib))
! end do
!ENDDEBUG

end subroutine diago_hamilt



!!***
