!{\src2tex{textfont=tt}}
!!****f* ABINIT/wrqps
!! NAME
!! wrqps
!!
!! FUNCTION
!!  N/D [FIXME]
!!
!! COPYRIGHT
!!  Copyright (C) 2005-2006 ABINIT group (FBruneval)
!!  This file is distributed under the terms of the
!!  GNU General Public License, see ~abinit/COPYING
!!  or http://www.gnu.org/copyleft/gpl.txt .
!!
!! INPUTS
!!  argin(sizein)=description
!!
!! OUTPUT
!!  argout(sizeout)=description
!!
!! SIDE EFFECTS
!!
!! NOTES
!!
!! PARENTS
!!      sigma
!!
!! CHILDREN
!!
!! SOURCE

#if defined HAVE_CONFIG_H
#include "config.h"
#endif

subroutine wrqps(dtfil,gwcalctyp,nk,nb,kibz,nscf,en_qp,eigvec_qp,m_lda_to_qp)

 use defs_basis
 use defs_datatypes

 implicit none

!Arguments ------------------------------------
!scalars
 integer,intent(in) :: gwcalctyp,nb,nk,nscf
 type(datafiles_type),intent(in) :: dtfil
!arrays
 real(dp),intent(in) :: en_qp(nb,nk),kibz(3,nk)
 complex,intent(in) :: eigvec_qp(nb,nb,nk),m_lda_to_qp(nb,nb,nk)

!Local variables-------------------------------
!scalars
 integer,parameter :: unitfile=999
 integer :: ib,ik
 character(len=fnlen) :: filnam
!arrays
 complex :: mtmp(nb,nb)

! *************************************************************************

!if non self-consistent calculation, exit immediately
 if(gwcalctyp<10) return

 filnam=trim(dtfil%filnam_ds(4))//'_QPS'
 open(unit=unitfile,file=trim(filnam),form='formatted',status='unknown')
 write(*,*) 'writing out the QP data in file '//trim(dtfil%filnam_ds(4))//'_QPS'

 write(unitfile,*) nscf+1
 write(unitfile,*) nk
 write(unitfile,*) nb

 do ik=1,nk
!calculate the new m_lda_to_qp
  mtmp(:,:)=matmul(m_lda_to_qp(:,:,ik),eigvec_qp(:,:,ik))

  write(unitfile,*) kibz(:,ik)
  do ib=1,nb
   write(unitfile,*) en_qp(ib,ik)
   write(unitfile,*) mtmp(:,ib)
  end do !ib
 end do !ik

 close(unitfile)


end subroutine wrqps
!!***
