!{\src2tex{textfont=tt}}
!!****f* ABINIT/iofn1_ncdf
!! NAME
!! iofn1_ncdf
!!
!! FUNCTION
!! Begin by eventual redefinition of unit 05 and 06
!! Then, print greetings for interactive user.
!! Next, Read filenames from unit 05, AND check that new
!! output file does not already exist.
!!
!! COPYRIGHT
!! Copyright (C) 1998-2006 ABINIT group (DCA, XG, GMR)
!! This file is distributed under the terms of the
!! GNU General Public License, see ~abinit/COPYING
!! or http://www.gnu.org/copyleft/gpl.txt .
!! For the initials of contributors, see ~abinit/doc/developers/contributors.
!!
!! INPUTS
!!
!! OUTPUT
!!  character(len=fnlen) :: filnam(5)=character strings giving file names
!!  character(len=fnlen) :: filstat=character strings giving name of status file
!!  logical              :: netcdf_input=whether the input file is NetCDF
!!
!! NOTES
!! If it does exist, isfile will create a new name to avoid overwriting
!! the output file.
!! Also creates name of status file.
!!
!! File names refer to following files, in order:
!!  (1) Formatted input file  (05)
!!  (2) Formatted output file (iout)
!!  (3) Root name for generic input files (wavefunctions, potential, density ...)
!!  (4) Root name for generic output files (wavefunctions, potential, density,
!!                                          DOS, hessian ...)
!!  (5) Root name for generic temporary files (wftmp1,wftmp2,kgunit,status ...)
!!
!! PARENTS
!!      abinit
!!
!! CHILDREN
!!      iofn1
!!
!! SOURCE

#if defined HAVE_CONFIG_H
#include "config.h"
#endif

!BEGIN TF_CHANGES
subroutine iofn1_ncdf(filnam,filstat,netcdf_input,mpi_enreg)
!END TF_CHANGES

 use defs_basis
!BEGIN TF_CHANGES
 use defs_datatypes
!END TF_CHANGES
#if defined HAVE_NETCDF
 use netcdf
#endif

!This section has been created automatically by the script Abilint (TD). Do not modify these by hand.
#ifdef HAVE_FORTRAN_INTERFACES
 use interfaces_08seqpar, except_this_one => iofn1_ncdf
#endif
!End of the abilint section

 implicit none

!Arguments ------------------------------------
 character(len=fnlen),intent(out) :: filstat
 character(len=fnlen),intent(out) :: filnam(5)
 logical             ,intent(out) :: netcdf_input
!BEGIN TF_CHANGES
 type(MPI_type), intent(in) :: mpi_enreg
!END TF_CHANGES

!Local variables-------------------------------
 character(len=fnlen) :: tmp1
 character(len=6) :: tmp2
 integer :: i

!BEGIN TF_CHANGES
 call iofn1(filnam,filstat,mpi_enreg)
!END TF_CHANGES

 if ( len(filnam(1)) > 7 ) then
  tmp1 = filnam(1)
  tmp2=tmp1(1:7)

  netcdf_input = ( tmp2 == 'NetCDF ' )

  if ( netcdf_input ) then
   filnam(1) = tmp1(8:)
  end if
 end if

end subroutine iofn1_ncdf
!!***
