!{\src2tex{textfont=tt}}
!!****m* ABINIT/defs_netcdf
!! NAME
!!  defs_netcdf
!!
!! FUNCTION
!!  This module contains definitions enabling the use of NetCDF library for
!!  file I/O.
!!
!! COPYRIGHT
!!  Copyright (C) 2005-2006 ABINIT group (YP)
!!  This file is distributed under the terms of the
!!  GNU General Public License, see ~abinit/COPYING
!!  or http://www.gnu.org/copyleft/gpl.txt .
!!
!! SOURCE

#if defined HAVE_CONFIG_H
#include "config.h"
#endif

module defs_netcdf

 use defs_basis

 implicit none

! Constants
!-------------------------------------------------------------------------------

 integer,parameter :: NCBLKS = 6

 integer,parameter :: NCBLK_HEADER  =   1
 integer,parameter :: NCBLK_DATASET =   2
 integer,parameter :: NCBLK_SYSTEM  =   4
 integer,parameter :: NCBLK_WFS     =   8
 integer,parameter :: NCBLK_DENSITY =  16
 integer,parameter :: NCBLK_ACFD    =  32

! Complex types
!-------------------------------------------------------------------------------

 type ncdims_type

  integer :: mband,ntypat,natom,natsph,nkpt,nkptgw,nshiftk,nsppol,nberry,&
&            nsym,npsp,nconeq,ntypalch,npspalch,nfft,nspden,wfs_dim1,wfs_dim2,&
&            nfreqsus,npw_tiny,nqptdm,norb,ncenter

 end type ncdims_type

 type ncacfd_type

  integer  :: ifreq
  real(dp) :: ex_cc,ecs_cc,ecgl_cc,n_test

  real(dp),pointer :: freqs(:),weights(:),ecs_uc(:),ecgl_uc(:)

 end type ncacfd_type

end module defs_netcdf
!!***
