!!****m* ABINIT/interfaces_01managempi
!! NAME
!! interfaces_01managempi
!!
!! FUNCTION
!! This module contains the interfaces of the routines
!! in the directory src/01managempi
!!
!! COPYRIGHT
!! Copyright (C) 2005 ABINIT group
!! This file is distributed under the terms of the
!! GNU General Public License, see ~abinit/COPYING
!! or http://www.gnu.org/copyleft/gpl.txt .
!!
!! NOTES
!! THIS FILE IS GENERATED AUTOMATICALLY BY abilint.
!! To do that: abilint . .
!!             (see util/maintainers/abilint.py)
!!
!! SOURCE

module interfaces_01managempi

 interface
  subroutine chkexi(cpus,filnam,iexit,iout,mpi_enreg,openexit)
   use defs_basis
   use defs_datatypes
   integer          ,intent(out) :: iexit
   integer          ,intent(in) :: iout
   integer          ,intent(in) :: openexit
   real(dp)         ,intent(in) :: cpus
   character(len=fnlen),intent(in) :: filnam
   type(MPI_type)   ,intent(inout) :: mpi_enreg
  end subroutine chkexi
 end interface

 interface
  subroutine clnmpi_fft(dtset, mpi_enreg)
   use defs_datatypes
   type(dataset_type), intent(in) :: dtset
   type(MPI_type), intent(inout) :: mpi_enreg
  end subroutine clnmpi_fft
 end interface

 interface
  subroutine clnmpi_gs(dtset, mpi_enreg)
   use defs_datatypes
   type(dataset_type) :: dtset
   type(MPI_type) :: mpi_enreg
  end subroutine clnmpi_gs
 end interface

 interface
  subroutine distrb2(mband, nband, nkpt, nsppol, mpi_enreg)
   use defs_datatypes
   integer,intent(in) :: mband
   integer,intent(in) :: nkpt
   integer,intent(in) :: nsppol
   type(MPI_type),intent(inout) :: mpi_enreg
   integer,intent(in) :: nband(nkpt*nsppol)
  end subroutine distrb2
 end interface

 interface
  subroutine handle_ncerr(ncerr,message)
   integer         ,intent(in) :: ncerr
   character(len=*),intent(in) :: message
  end subroutine handle_ncerr
 end interface

 interface
  subroutine hdr_comm(hdr,master,me,spaceComm)
   use defs_datatypes
   integer, intent(in) :: master
   integer, intent(in) :: me
   integer, intent(in) :: spaceComm
   type(hdr_type),intent(inout) :: hdr
  end subroutine hdr_comm
 end interface


!Generic interface of the routines hdr_io
 interface hdr_io

  subroutine hdr_io_wfftype(fform,hdr,rdwr,wff)
   use defs_datatypes
   integer,intent(inout) :: fform
   integer,intent(in) :: rdwr
   type(hdr_type),intent(inout) :: hdr
   type(wffile_type),intent(inout) :: wff
  end subroutine hdr_io_wfftype

  subroutine hdr_io_int(fform,hdr,rdwr,unitfi)
   use defs_datatypes
   integer,intent(inout) :: fform
   integer,intent(in) :: rdwr
   integer,intent(in) :: unitfi
   type(hdr_type),intent(inout) :: hdr
  end subroutine hdr_io_int

 end interface
!End of the generic interface of hdr_io



!Generic interface of the routines hdr_io_netcdf
 interface hdr_io_netcdf

  subroutine hdr_io_netcdf_wfftype(fform,hdr,rdwr,wff)
   use defs_datatypes
   integer,intent(inout) :: fform
   integer,intent(in) :: rdwr
   type(hdr_type),intent(inout) :: hdr
   type(wffile_type),intent(inout) :: wff
  end subroutine hdr_io_netcdf_wfftype

  subroutine hdr_io_netcdf_int(fform,hdr,rdwr,unitfi)
   use defs_datatypes
   integer,intent(inout) :: fform
   integer,intent(in) :: rdwr
   integer,intent(in) :: unitfi
   type(hdr_type),intent(inout) :: hdr
  end subroutine hdr_io_netcdf_int

 end interface
!End of the generic interface of hdr_io_netcdf



!Generic interface of the routines hdr_skip
 interface hdr_skip

  subroutine hdr_skip_int(unitfi,ierr)
   integer, intent(out) :: ierr
   integer, intent(in) :: unitfi
  end subroutine hdr_skip_int

  subroutine hdr_skip_wfftype(wff,ierr)
   use defs_datatypes
   integer, intent(out) :: ierr
   type(wffile_type),intent(inout) :: wff
  end subroutine hdr_skip_wfftype

 end interface
!End of the generic interface of hdr_skip


 interface
  subroutine herald(code_name,code_version,iout)
   integer,intent(in) :: iout
   character(len=24),intent(in) :: code_name
   character(len=6),intent(in) :: code_version
  end subroutine herald
 end interface

 interface
  subroutine ini_wf_netcdf(mpw,ncid_hdr,response)
   integer, intent(in) :: mpw
   integer, intent(in) :: ncid_hdr
   integer, intent(in) :: response
  end subroutine ini_wf_netcdf
 end interface

 interface
  subroutine initmpi_fft(dtset,mpi_enreg)
   use defs_datatypes
   type(dataset_type),intent(in) :: dtset
   type(MPI_type),intent(inout) :: mpi_enreg
  end subroutine initmpi_fft
 end interface

 interface
  subroutine initmpi_gs(dtset,mpi_enreg)
   use defs_datatypes
   type(dataset_type),intent(in) :: dtset
   type(MPI_type),intent(inout) :: mpi_enreg
  end subroutine initmpi_gs
 end interface

 interface
  subroutine initmpi_respfn(mpi_enreg, spaceComm)
   use defs_datatypes
   integer :: spaceComm
   type(MPI_type) :: mpi_enreg
  end subroutine initmpi_respfn
 end interface

 interface
  subroutine initmpi_seq(mpi_enreg)
   use defs_datatypes
   type(MPI_type),intent(out) :: mpi_enreg
  end subroutine initmpi_seq
 end interface

 interface
  subroutine leave_new(mode_paral)
   character(len=4),intent(in) :: mode_paral
  end subroutine leave_new
 end interface

 interface
  subroutine leave_test(mpi_enreg)
   use defs_datatypes
   type(MPI_type) :: mpi_enreg
  end subroutine leave_test
 end interface

 interface
  subroutine outxfhist(nxfh,natom,mxfh,xfhist,option,wff2,ios)
   use defs_basis
   use defs_datatypes
   integer          ,intent(out) :: ios
   integer          ,intent(in) :: mxfh
   integer          ,intent(in) :: natom
   integer          ,intent(inout) :: nxfh
   integer          ,intent(in) :: option
   type(wffile_type),intent(inout) :: wff2
   real(dp)         ,intent(inout) :: xfhist(3,natom+4,2,mxfh)
  end subroutine outxfhist
 end interface

 interface
  subroutine rwwf(cg,eigen,formeig,headform,icg,ikpt,isppol,kg_k,mband,mcg,nband,nband_disk,&  
&  npw,nspinor,occ,option,optkg,tim_rwwf,wff)
   use defs_basis
   use defs_datatypes
   integer,intent(in) :: formeig
   integer,intent(in) :: headform
   integer,intent(in) :: icg
   integer,intent(in) :: ikpt
   integer,intent(in) :: isppol
   integer,intent(in) :: mband
   integer,intent(in) :: mcg
   integer,intent(in) :: nband
   integer,intent(inout) :: nband_disk
   integer,intent(in) :: npw
   integer,intent(in) :: nspinor
   integer,intent(in) :: option
   integer,intent(in) :: optkg
   integer,intent(in) :: tim_rwwf
   type(wffile_type),intent(inout) :: wff
   real(dp),intent(inout) :: cg(2,mcg)
   real(dp),intent(inout) :: eigen((2*mband)**formeig*mband)
   integer,intent(inout) :: kg_k(3,optkg*npw)
   real(dp),intent(inout) :: occ(mband)
  end subroutine rwwf
 end interface

 interface
  subroutine WffClose(wff,ier)
   use defs_datatypes
   integer, intent(out) :: ier
   type(wffile_type), intent(inout) :: wff
  end subroutine WffClose
 end interface

 interface
  subroutine WffDelete(wff,ier)
   use defs_datatypes
   integer, intent(out) :: ier
   type(wffile_type),intent(inout) :: wff
  end subroutine WffDelete
 end interface

 interface
  subroutine WffKg(wff,optkg)
   use defs_datatypes
   integer          ,intent(in) :: optkg
   type(wffile_type),intent(inout) :: wff
  end subroutine WffKg
 end interface

 interface
  subroutine WffOffset(wff,sender,spaceComm,ier)
   use defs_datatypes
   integer          ,intent(out) :: ier
   integer          ,intent(inout) :: sender
   integer          ,intent(in) :: spaceComm
   type(wffile_type),intent(inout) :: wff
  end subroutine WffOffset
 end interface

 interface
  subroutine WffOpen(accesswff,spaceComm,filename,ier,wff,master,me,unwff)
   use defs_basis
   use defs_datatypes
   integer, intent(in) :: accesswff
   integer, intent(out) :: ier
   integer, intent(in) :: master
   integer, intent(in) :: me
   integer, intent(in) :: spaceComm
   integer, intent(in) :: unwff
   character(len=fnlen), intent(in) :: filename
   type(wffile_type), intent(out) :: wff
  end subroutine WffOpen
 end interface

 interface
  subroutine WffReadDataRec(dparray,ierr,ndp,wff)
   use defs_basis
   use defs_datatypes
   integer, intent(out) :: ierr
   integer, intent(in) :: ndp
   type(wffile_type), intent(inout) :: wff
   real(dp), intent(out) :: dparray(ndp)
  end subroutine WffReadDataRec
 end interface

 interface
  subroutine WffReadNpwRec(ierr,ikpt,nband_disk,npw,nspinor,wff)
   use defs_datatypes
   integer,intent(out) :: ierr
   integer,intent(in) :: ikpt
   integer,intent(out) :: nband_disk
   integer,intent(out) :: npw
   integer,intent(out) :: nspinor
   type(wffile_type),intent(inout) :: wff
  end subroutine WffReadNpwRec
 end interface

 interface
  subroutine WffReadSkipRec(ierr,nrec,wff)
   use defs_datatypes
   integer          ,intent(out) :: ierr
   integer          ,intent(in) :: nrec
   type(wffile_type),intent(inout) :: wff
  end subroutine WffReadSkipRec
 end interface

 interface
  subroutine WffWriteDataRec(dparray,ierr,ndp,wff)
   use defs_basis
   use defs_datatypes
   integer, intent(out) :: ierr
   integer, intent(in) :: ndp
   type(wffile_type), intent(inout) :: wff
   real(dp), intent(in) :: dparray(ndp)
  end subroutine WffWriteDataRec
 end interface

 interface
  subroutine WffWriteDataRecInt(intarray,ierr,nn,wff)
   use defs_datatypes
   integer, intent(out) :: ierr
   integer, intent(in) :: nn
   type(wffile_type), intent(inout) :: wff
   integer, intent(in) :: intarray(nn)
  end subroutine WffWriteDataRecInt
 end interface

 interface
  subroutine WffWriteNpwRec(ierr,nband_disk,npw,nspinor,wff)
   use defs_datatypes
   integer, intent(out) :: ierr
   integer, intent(in) :: nband_disk
   integer, intent(in) :: npw
   integer, intent(in) :: nspinor
   type(wffile_type), intent(inout) :: wff
  end subroutine WffWriteNpwRec
 end interface

 interface
  subroutine wrtout(unit,message,mode_paral)
   integer,intent(in) :: unit
   character(len=500),intent(inout) :: message
   character(len=4),intent(in) :: mode_paral
  end subroutine wrtout
 end interface


!Generic interface of the routines xallgather_mpi
 interface xallgather_mpi

  subroutine xallgather_mpi_int(xval,recvcounts,spaceComm,ier)
   integer,intent(out) :: ier
   integer,intent(in) :: spaceComm
   integer,intent(inout) :: xval
   integer,intent(inout) :: recvcounts(:)
  end subroutine xallgather_mpi_int

  subroutine xallgather_mpi_dp4d(xval,nelem,recvcounts,spaceComm,ier)
   use defs_basis
   integer ,intent(out) :: ier
   integer ,intent(in) :: nelem
   integer ,intent(in) :: spaceComm
   real(dp),intent(inout) :: recvcounts(:,:,:,:)
   real(dp),intent(in) :: xval(:,:,:,:)
  end subroutine xallgather_mpi_dp4d

 end interface
!End of the generic interface of xallgather_mpi



!Generic interface of the routines xallgatherv_mpi
 interface xallgatherv_mpi

  subroutine xallgatherv_mpi_int2d(xval,nelem,recvbuf,recvcounts,displs,spaceComm,ier)
   integer,intent(out) :: ier
   integer,intent(in) :: nelem
   integer,intent(in) :: spaceComm
   integer,intent(in) :: displs(:)
   integer,intent(inout) :: recvbuf(:,:)
   integer,intent(in) :: recvcounts(:)
   integer,intent(in) :: xval(:,:)
  end subroutine xallgatherv_mpi_int2d

  subroutine xallgatherv_mpi_int(xval,nelem,recvbuf,recvcounts,displs,spaceComm,ier)
   integer,intent(out) :: ier
   integer,intent(in) :: nelem
   integer,intent(in) :: spaceComm
   integer,intent(in) :: displs(:)
   integer,intent(inout) :: recvbuf(:)
   integer,intent(in) :: recvcounts(:)
   integer,intent(in) :: xval(:)
  end subroutine xallgatherv_mpi_int

  subroutine xallgatherv_mpi_dp(xval,nelem,recvbuf,recvcounts,displs,spaceComm,ier)
   use defs_basis
   integer,intent(out) :: ier
   integer,intent(in) :: nelem
   integer,intent(in) :: spaceComm
   integer,intent(in) :: displs(:)
   real(dp),intent(inout) :: recvbuf(:)
   integer,intent(in) :: recvcounts(:)
   real(dp),intent(in) :: xval(:)
  end subroutine xallgatherv_mpi_dp

  subroutine xallgatherv_mpi_dp2d(xval,nelem,recvbuf,recvcounts,displs,spaceComm,ier)
   use defs_basis
   integer,intent(out) :: ier
   integer,intent(in) :: nelem
   integer,intent(in) :: spaceComm
   integer,intent(in) :: displs(:)
   real(dp),intent(inout) :: recvbuf(:,:)
   integer,intent(in) :: recvcounts(:)
   real(dp),intent(in) :: xval(:,:)
  end subroutine xallgatherv_mpi_dp2d

  subroutine xallgatherv_mpi_dp3d(xval,nelem,recvbuf,recvcounts,displs,spaceComm,ier)
   use defs_basis
   integer,intent(out) :: ier
   integer,intent(in) :: nelem
   integer,intent(in) :: spaceComm
   integer,intent(in) :: displs(:)
   real(dp),intent(inout) :: recvbuf(:,:,:)
   integer,intent(in) :: recvcounts(:)
   real(dp),intent(in) :: xval(:,:,:)
  end subroutine xallgatherv_mpi_dp3d

  subroutine xallgatherv_mpi_dp4d(xval,nelem,recvbuf,recvcounts,displs,spaceComm,ier)
   use defs_basis
   integer,intent(out) :: ier
   integer,intent(in) :: nelem
   integer,intent(in) :: spaceComm
   integer,intent(in) :: displs(:)
   real(dp),intent(inout) :: recvbuf(:,:,:,:)
   integer,intent(in) :: recvcounts(:)
   real(dp),intent(in) :: xval(:,:,:,:)
  end subroutine xallgatherv_mpi_dp4d

 end interface
!End of the generic interface of xallgatherv_mpi



!Generic interface of the routines xalltoallv_mpi
 interface xalltoallv_mpi

  subroutine xalltoallv_mpi_dp2d(xval,sendcnts,sdispls,recvbuf,recvcnts,rdispls,spaceComm,ier)
   use defs_basis
   integer ,intent(out) :: ier
   integer ,intent(in) :: spaceComm
   integer ,intent(in) :: rdispls(:)
   real(dp),intent(inout) :: recvbuf(:,:)
   integer ,intent(in) :: recvcnts(:)
   integer ,intent(in) :: sdispls(:)
   integer ,intent(in) :: sendcnts(:)
   real(dp),intent(in) :: xval(:,:)
  end subroutine xalltoallv_mpi_dp2d

 end interface
!End of the generic interface of xalltoallv_mpi


 interface
  subroutine xcomm_world(mpi_enreg,spaceComm)
   use defs_datatypes
   integer,intent(out) :: spaceComm
   type(MPI_type) :: mpi_enreg
  end subroutine xcomm_world
 end interface

 interface
  subroutine xcomm_init(mpi_enreg,spaceComm)
   use defs_datatypes
   integer,intent(out) :: spaceComm
   type(MPI_type),intent(in) :: mpi_enreg
  end subroutine xcomm_init
 end interface

 interface
  subroutine xmaster_init(mpi_enreg,master)
   use defs_datatypes
   integer,intent(out) :: master
   type(MPI_type),intent(in) :: mpi_enreg
  end subroutine xmaster_init
 end interface

 interface
  subroutine xmaster_init_fft(mpi_enreg,master)
   use defs_datatypes
   integer,intent(out) :: master
   type(MPI_type),intent(in) :: mpi_enreg
  end subroutine xmaster_init_fft
 end interface

 interface
  subroutine xme_init(mpi_enreg,me)
   use defs_datatypes
   integer,intent(out) :: me
   type(MPI_type),intent(in) :: mpi_enreg
  end subroutine xme_init
 end interface

 interface
  subroutine xproc_init(mpi_enreg,nproc_max)
   use defs_datatypes
   integer,intent(out) :: nproc_max
   type(MPI_type),intent(in) :: mpi_enreg
  end subroutine xproc_init
 end interface

 interface
  subroutine xme_whoiam(me)
   integer,intent(out) :: me
  end subroutine xme_whoiam
 end interface

 interface
  subroutine xproc_max(nproc,ierr)
   integer,intent(out) :: ierr
   integer,intent(out) :: nproc
  end subroutine xproc_max
 end interface

 interface
  subroutine xdefineOff(formeig,wff,mpi_enreg,nband,npwarr,nspinor,nsppol,nkpt)
   use defs_datatypes
   integer, intent(in) :: formeig
   integer, intent(in) :: nkpt
   integer, intent(in) :: nspinor
   integer, intent(in) :: nsppol
   type(MPI_type),intent(in) :: mpi_enreg
   type(wffile_type),intent(inout) :: wff
   integer, intent(in) :: nband(nkpt*nsppol)
   integer, intent(in) :: npwarr(nkpt)
  end subroutine xdefineOff
 end interface

 interface
  subroutine xderiveWRecEnd(wff,ierr)
   use defs_datatypes
   integer,intent(out) :: ierr
   type(wffile_type),intent(inout) :: wff
  end subroutine xderiveWRecEnd
 end interface

 interface
  subroutine xderiveWRecInit(wff,ierr)
   use defs_datatypes
   integer,intent(out) :: ierr
   type(wffile_type),intent(inout) :: wff
  end subroutine xderiveWRecInit
 end interface

 interface
  subroutine xderiveRRecEnd(wff,ierr)
   use defs_datatypes
   integer,intent(out) :: ierr
   type(wffile_type),intent(inout) :: wff
  end subroutine xderiveRRecEnd
 end interface

 interface
  subroutine xderiveRRecInit(wff,ierr)
   use defs_datatypes
   integer,intent(out) :: ierr
   type(wffile_type),intent(inout) :: wff
  end subroutine xderiveRRecInit
 end interface


!Generic interface of the routines xderiveread
 interface xderiveread

  subroutine xderiveRead_int(wff,xval,n1,ierr)
   use defs_datatypes
   integer,intent(out) :: ierr
   integer,intent(in) :: n1
   type(wffile_type),intent(inout) :: wff
   integer,intent(out) :: xval(:)
  end subroutine xderiveRead_int

  subroutine xderiveRead_int2d(wff,xval,n1,n2,ierr)
   use defs_datatypes
   integer,intent(out) :: ierr
   integer,intent(in) :: n1
   integer,intent(in) :: n2
   type(wffile_type),intent(inout) :: wff
   integer,intent(out) :: xval(:,:)
  end subroutine xderiveRead_int2d

  subroutine xderiveRead_dp(wff,xval,n1,ierr)
   use defs_basis
   use defs_datatypes
   integer,intent(out) :: ierr
   integer,intent(in) :: n1
   type(wffile_type),intent(inout) :: wff
   real(dp),intent(out) :: xval(:)
  end subroutine xderiveRead_dp

  subroutine xderiveRead_dp2d(wff,xval,n1,n2,ierr)
   use defs_basis
   use defs_datatypes
   integer,intent(out) :: ierr
   integer,intent(in) :: n1
   integer,intent(in) :: n2
   type(wffile_type),intent(inout) :: wff
   real(dp),intent(out) :: xval(:,:)
  end subroutine xderiveRead_dp2d

 end interface
!End of the generic interface of xderiveread



!Generic interface of the routines xderivereadval
 interface xderivereadval

  subroutine xderiveReadVal_dp(wff,xval)
   use defs_basis
   use defs_datatypes
   type(wffile_type),intent(inout) :: wff
   real(dp),intent(out) :: xval
  end subroutine xderiveReadVal_dp

  subroutine xderiveReadVal_int(wff,xval)
   use defs_datatypes
   integer,intent(out) :: xval
   type(wffile_type),intent(inout) :: wff
  end subroutine xderiveReadVal_int

  subroutine xderiveReadVal_char(wff,xval,n)
   use defs_datatypes
   integer,intent(in) :: n
   type(wffile_type),intent(inout) :: wff
   character(len=*),intent(out) :: xval
  end subroutine xderiveReadVal_char

 end interface
!End of the generic interface of xderivereadval



!Generic interface of the routines xderivewrite
 interface xderivewrite

  subroutine xderiveWrite_int(wff,xval,n1,ierr)
   use defs_datatypes
   integer,intent(out) :: ierr
   integer,intent(in) :: n1
   type(wffile_type),intent(inout) :: wff
   integer,intent(in) :: xval(:)
  end subroutine xderiveWrite_int

  subroutine xderiveWrite_int2d(wff,xval,n1,n2,ierr)
   use defs_datatypes
   integer,intent(out) :: ierr
   integer,intent(in) :: n1
   integer,intent(in) :: n2
   type(wffile_type),intent(inout) :: wff
   integer,intent(in) :: xval(:,:)
  end subroutine xderiveWrite_int2d

  subroutine xderiveWrite_dp(wff,xval,n1,ierr)
   use defs_basis
   use defs_datatypes
   integer,intent(out) :: ierr
   integer,intent(in) :: n1
   type(wffile_type),intent(inout) :: wff
   real(dp),intent(in) :: xval(:)
  end subroutine xderiveWrite_dp

  subroutine xderiveWrite_dp2d(wff,xval,n1,n2,ierr)
   use defs_basis
   use defs_datatypes
   integer,intent(out) :: ierr
   integer,intent(in) :: n1
   integer,intent(in) :: n2
   type(wffile_type),intent(inout) :: wff
   real(dp),intent(in) :: xval(:,:)
  end subroutine xderiveWrite_dp2d

 end interface
!End of the generic interface of xderivewrite



!Generic interface of the routines xderivewriteval
 interface xderivewriteval

  subroutine xderiveWriteVal_dp(wff,xval)
   use defs_basis
   use defs_datatypes
   type(wffile_type),intent(inout) :: wff
   real(dp),intent(in) :: xval
  end subroutine xderiveWriteVal_dp

  subroutine xderiveWriteVal_int(wff,xval)
   use defs_datatypes
   integer,intent(in) :: xval
   type(wffile_type),intent(inout) :: wff
  end subroutine xderiveWriteVal_int

  subroutine xderiveWriteVal_char(wff,xval,n)
   use defs_datatypes
   integer,intent(in) :: n
   type(wffile_type),intent(inout) :: wff
   character(len=*),intent(in) :: xval
  end subroutine xderiveWriteVal_char

 end interface
!End of the generic interface of xderivewriteval



!Generic interface of the routines xexch_mpi
 interface xexch_mpi

  subroutine xexch_mpi_intn(vsend,n1,sender,vrecv,recever,spaceComm,ier)
   integer,intent(out) :: ier
   integer,intent(in) :: n1
   integer,intent(in) :: recever
   integer,intent(in) :: sender
   integer,intent(in) :: spaceComm
   integer,intent(inout) :: vrecv(:)
   integer,intent(in) :: vsend(:)
  end subroutine xexch_mpi_intn

  subroutine xexch_mpi_int2d(vsend,nt,sender,vrecv,recever,spaceComm,ier)
   integer,intent(out) :: ier
   integer,intent(in) :: nt
   integer,intent(in) :: recever
   integer,intent(in) :: sender
   integer,intent(in) :: spaceComm
   integer,intent(inout) :: vrecv(:,:)
   integer,intent(in) :: vsend(:,:)
  end subroutine xexch_mpi_int2d

  subroutine xexch_mpi_dpn(vsend,n1,sender,vrecv,recever,spaceComm,ier)
   use defs_basis
   integer,intent(out) :: ier
   integer,intent(in) :: n1
   integer,intent(in) :: recever
   integer,intent(in) :: sender
   integer,intent(in) :: spaceComm
   real(dp),intent(inout) :: vrecv(:)
   real(dp),intent(in) :: vsend(:)
  end subroutine xexch_mpi_dpn

  subroutine xexch_mpi_dp2d(vsend,nt,sender,vrecv,recever,spaceComm,ier)
   use defs_basis
   integer,intent(out) :: ier
   integer,intent(in) :: nt
   integer,intent(in) :: recever
   integer,intent(in) :: sender
   integer,intent(in) :: spaceComm
   real(dp),intent(inout) :: vrecv(:,:)
   real(dp),intent(in) :: vsend(:,:)
  end subroutine xexch_mpi_dp2d

  subroutine xexch_mpi_dp3d(vsend,nt,sender,vrecv,recever,spaceComm,ier)
   use defs_basis
   integer,intent(out) :: ier
   integer,intent(in) :: nt
   integer,intent(in) :: recever
   integer,intent(in) :: sender
   integer,intent(in) :: spaceComm
   real(dp),intent(inout) :: vrecv(:,:,:)
   real(dp),intent(in) :: vsend(:,:,:)
  end subroutine xexch_mpi_dp3d

 end interface
!End of the generic interface of xexch_mpi



!Generic interface of the routines xmax_mpi
 interface xmax_mpi

  subroutine xmax_mpi_intv(xval,xmax,spaceComm,ier)
   integer ,intent(out) :: ier
   integer ,intent(in) :: spaceComm
   integer ,intent(inout) :: xmax
   integer ,intent(inout) :: xval
  end subroutine xmax_mpi_intv

  subroutine xmax_mpi_dpv(xval,xmax,spaceComm,ier)
   use defs_basis
   integer ,intent(out) :: ier
   integer ,intent(in) :: spaceComm
   real(dp),intent(inout) :: xmax
   real(dp),intent(inout) :: xval
  end subroutine xmax_mpi_dpv

 end interface
!End of the generic interface of xmax_mpi



!Generic interface of the routines xmin_mpi
 interface xmin_mpi

  subroutine xmin_mpi_intv(xval,xmin,spaceComm,ier)
   integer ,intent(out) :: ier
   integer ,intent(in) :: spaceComm
   integer ,intent(inout) :: xmin
   integer ,intent(inout) :: xval
  end subroutine xmin_mpi_intv

  subroutine xmin_mpi_dpv(xval,xmin,spaceComm,ier)
   use defs_basis
   integer ,intent(out) :: ier
   integer ,intent(in) :: spaceComm
   real(dp),intent(inout) :: xmin
   real(dp),intent(inout) :: xval
  end subroutine xmin_mpi_dpv

 end interface
!End of the generic interface of xmin_mpi



!Generic interface of the routines xsum_master
 interface xsum_master

  subroutine xsum_master_dp2d(xval,master,spaceComm,ier)
   use defs_basis
   integer ,intent(out) :: ier
   integer ,intent(in) :: master
   integer ,intent(in) :: spaceComm
   real(dp),intent(inout) :: xval(:,:)
  end subroutine xsum_master_dp2d

  subroutine xsum_master_dp3d(xval,master,spaceComm,ier)
   use defs_basis
   integer ,intent(out) :: ier
   integer ,intent(in) :: master
   integer ,intent(in) :: spaceComm
   real(dp),intent(inout) :: xval(:,:,:)
  end subroutine xsum_master_dp3d

  subroutine xsum_master_dp4d(xval,master,spaceComm,ier)
   use defs_basis
   integer ,intent(out) :: ier
   integer ,intent(in) :: master
   integer ,intent(in) :: spaceComm
   real(dp),intent(inout) :: xval(:,:,:,:)
  end subroutine xsum_master_dp4d

  subroutine xsum_master_dp5d(xval,master,spaceComm,ier)
   use defs_basis
   integer ,intent(out) :: ier
   integer ,intent(in) :: master
   integer ,intent(in) :: spaceComm
   real(dp),intent(inout) :: xval(:,:,:,:,:)
  end subroutine xsum_master_dp5d

  subroutine xsum_master_int4d(xval,master,spaceComm,ier)
   integer ,intent(out) :: ier
   integer ,intent(in) :: master
   integer ,intent(in) :: spaceComm
   integer ,intent(inout) :: xval(:,:,:,:)
  end subroutine xsum_master_int4d

  subroutine xsum_master_c3cplx(xval,master,spaceComm,ier)
   integer ,intent(out) :: ier
   integer ,intent(in) :: master
   integer ,intent(in) :: spaceComm
   complex ,intent(inout) :: xval(:,:,:)
  end subroutine xsum_master_c3cplx

 end interface
!End of the generic interface of xsum_master



!Generic interface of the routines xsum_mpi
 interface xsum_mpi

  subroutine xsum_mpi_int(xval,spaceComm,ier)
   integer,intent(out) :: ier
   integer,intent(in) :: spaceComm
   integer,intent(inout) :: xval(:)
  end subroutine xsum_mpi_int

  subroutine xsum_mpi_intv(xval,spaceComm,ier)
   integer,intent(out) :: ier
   integer,intent(in) :: spaceComm
   integer,intent(inout) :: xval
  end subroutine xsum_mpi_intv

  subroutine xsum_mpi_intv2(xval,xsum,spaceComm,ier)
   integer,intent(out) :: ier
   integer,intent(in) :: spaceComm
   integer,intent(inout) :: xsum
   integer,intent(inout) :: xval
  end subroutine xsum_mpi_intv2

  subroutine xsum_mpi_intn(xval,n1,spaceComm,ier)
   integer,intent(out) :: ier
   integer,intent(in) :: n1
   integer,intent(in) :: spaceComm
   integer,intent(inout) :: xval(:)
  end subroutine xsum_mpi_intn

  subroutine xsum_mpi_int2d(xval,spaceComm,ier)
   integer,intent(out) :: ier
   integer,intent(in) :: spaceComm
   integer,intent(inout) :: xval(:,:)
  end subroutine xsum_mpi_int2d

  subroutine xsum_mpi_int3d(xval,spaceComm,ier)
   integer,intent(out) :: ier
   integer,intent(in) :: spaceComm
   integer,intent(inout) :: xval(:,:,:)
  end subroutine xsum_mpi_int3d

  subroutine xsum_mpi_dp(xval,spaceComm,ier)
   use defs_basis
   integer ,intent(out) :: ier
   integer ,intent(in) :: spaceComm
   real(dp),intent(inout) :: xval(:)
  end subroutine xsum_mpi_dp

  subroutine xsum_mpi_dpv(xval,spaceComm,ier)
   use defs_basis
   integer ,intent(out) :: ier
   integer ,intent(in) :: spaceComm
   real(dp),intent(inout) :: xval
  end subroutine xsum_mpi_dpv

  subroutine xsum_mpi_dpn(xval,n1,spaceComm,ier)
   use defs_basis
   integer ,intent(out) :: ier
   integer ,intent(in) :: n1
   integer ,intent(in) :: spaceComm
   real(dp),intent(inout) :: xval(:)
  end subroutine xsum_mpi_dpn

  subroutine xsum_mpi_dp2d(xval,spaceComm,ier)
   use defs_basis
   integer ,intent(out) :: ier
   integer ,intent(in) :: spaceComm
   real(dp),intent(inout) :: xval(:,:)
  end subroutine xsum_mpi_dp2d

  subroutine xsum_mpi_dp3d(xval,spaceComm,ier)
   use defs_basis
   integer ,intent(out) :: ier
   integer ,intent(in) :: spaceComm
   real(dp),intent(inout) :: xval(:,:,:)
  end subroutine xsum_mpi_dp3d

  subroutine xsum_mpi_dp4d(xval,spaceComm,ier)
   use defs_basis
   integer ,intent(out) :: ier
   integer ,intent(in) :: spaceComm
   real(dp),intent(inout) :: xval(:,:,:,:)
  end subroutine xsum_mpi_dp4d

  subroutine xsum_mpi_dp5d(xval,spaceComm,ier)
   use defs_basis
   integer ,intent(out) :: ier
   integer ,intent(in) :: spaceComm
   real(dp),intent(inout) :: xval(:,:,:,:,:)
  end subroutine xsum_mpi_dp5d

  subroutine xsum_mpi_dp6d(xval,spaceComm,ier)
   use defs_basis
   integer ,intent(out) :: ier
   integer ,intent(in) :: spaceComm
   real(dp),intent(inout) :: xval(:,:,:,:,:,:)
  end subroutine xsum_mpi_dp6d

  subroutine xsum_mpi_dp2t(xval,xsum,n1,spaceComm,ier)
   use defs_basis
   integer ,intent(out) :: ier
   integer ,intent(in) :: n1
   integer ,intent(in) :: spaceComm
   real(dp),intent(inout) :: xsum(:)
   real(dp),intent(inout) :: xval(:)
  end subroutine xsum_mpi_dp2t

  subroutine xsum_mpi_dp3d2t(xval,xsum,n1,spaceComm,ier)
   use defs_basis
   integer ,intent(out) :: ier
   integer ,intent(in) :: n1
   integer ,intent(in) :: spaceComm
   real(dp),intent(inout) :: xsum(:,:,:)
   real(dp),intent(inout) :: xval(:,:,:)
  end subroutine xsum_mpi_dp3d2t

  subroutine xsum_mpi_dp4d2t(xval,xsum,n1,spaceComm,ier)
   use defs_basis
   integer ,intent(out) :: ier
   integer ,intent(in) :: n1
   integer ,intent(in) :: spaceComm
   real(dp),intent(inout) :: xsum(:,:,:,:)
   real(dp),intent(inout) :: xval(:,:,:,:)
  end subroutine xsum_mpi_dp4d2t

  subroutine xsum_mpi_c2dc(xval,spaceComm,ier)
   use defs_basis
   integer,intent(out) :: ier
   integer,intent(in) :: spaceComm
   complex(dp),intent(inout) :: xval(:,:)
  end subroutine xsum_mpi_c2dc

  subroutine xsum_mpi_c3dc(xval,spaceComm,ier)
   use defs_basis
   integer,intent(out) :: ier
   integer,intent(in) :: spaceComm
   complex(dp),intent(inout) :: xval(:,:,:)
  end subroutine xsum_mpi_c3dc

  subroutine xsum_mpi_c2cplx(xval,spaceComm,ier)
   integer,intent(out) :: ier
   integer,intent(in) :: spaceComm
   complex,intent(inout) :: xval(:,:)
  end subroutine xsum_mpi_c2cplx

  subroutine xsum_mpi_c3cplx(xval,spaceComm,ier)
   integer,intent(out) :: ier
   integer,intent(in) :: spaceComm
   complex,intent(inout) :: xval(:,:,:)
  end subroutine xsum_mpi_c3cplx

 end interface
!End of the generic interface of xsum_mpi


end module interfaces_01managempi
!!***
