!!****m* ABINIT/interfaces_02poisson
!! NAME
!! interfaces_02poisson
!!
!! FUNCTION
!! This module contains the interfaces of the routines
!! in the directory src/02poisson
!!
!! COPYRIGHT
!! Copyright (C) 2005 ABINIT group
!! This file is distributed under the terms of the
!! GNU General Public License, see ~abinit/COPYING
!! or http://www.gnu.org/copyleft/gpl.txt .
!!
!! NOTES
!! THIS FILE IS GENERATED AUTOMATICALLY BY abilint.
!! To do that: abilint . .
!!             (see util/maintainers/abilint.py)
!!
!! SOURCE

module interfaces_02poisson

 interface
  subroutine Build_Kernel(n01,n02,n03,nfft1,nfft2,nfft3,hgrid,itype_scf,karrayout)
   integer, intent(in) :: itype_scf
   integer, intent(in) :: n01
   integer, intent(in) :: n02
   integer, intent(in) :: n03
   integer, intent(in) :: nfft1
   integer, intent(in) :: nfft2
   integer, intent(in) :: nfft3
   real(kind=8), intent(in) :: hgrid
   real(kind=8), dimension(nfft1/2+1,nfft2/2+1,nfft3/2+1), intent(out) :: karrayout
  end subroutine Build_Kernel
 end interface

 interface
  subroutine Dimensions_FFT(n01,n02,n03,nfft1,nfft2,nfft3)
   integer, intent(in) :: n01
   integer, intent(in) :: n02
   integer, intent(in) :: n03
   integer, intent(out) :: nfft1
   integer, intent(out) :: nfft2
   integer, intent(out) :: nfft3
  end subroutine Dimensions_FFT
 end interface

 interface
  subroutine karrayhalf_in(n01,n02,n03,n1k,n2k,n3k,nfft1,nfft2,nfft3,nd1,nd2,nd3,&  
     kernel,karrayhalf)
   integer, intent(in) :: n01
   integer, intent(in) :: n02
   integer, intent(in) :: n03
   integer, intent(in) :: n1k
   integer, intent(in) :: n2k
   integer, intent(in) :: n3k
   integer, intent(in) :: nd1
   integer, intent(in) :: nd2
   integer, intent(in) :: nd3
   integer, intent(in) :: nfft1
   integer, intent(in) :: nfft2
   integer, intent(in) :: nfft3
   real(kind=8), dimension(2,(nd1+1)/2,nd2,nd3), intent(out) :: karrayhalf
   real(kind=8), dimension(n1k,n2k,n3k), intent(in) :: kernel
  end subroutine karrayhalf_in
 end interface

 interface
  subroutine kernel_recon(n1k,n2k,n3k,nfft1,nfft2,nfft3,nd1,nd2,nd3,zarray,karray)
   integer, intent(in) :: n1k
   integer, intent(in) :: n2k
   integer, intent(in) :: n3k
   integer, intent(in) :: nd1
   integer, intent(in) :: nd2
   integer, intent(in) :: nd3
   integer, intent(in) :: nfft1
   integer, intent(in) :: nfft2
   integer, intent(in) :: nfft3
   real(kind=8), dimension(n1k,n2k,n3k), intent(out) :: karray
   real(kind=8), dimension(2,(nd1+1)/2*nd2*nd3), intent(in) :: zarray
  end subroutine kernel_recon
 end interface

 interface
  subroutine fourier_dim(n,n_next)
   integer, intent(in) :: n
   integer, intent(out) :: n_next
  end subroutine fourier_dim
 end interface

 interface
  subroutine fft3d_init(n1,n2,n3,nd1,nd2,nd3,zin,z)
   integer :: n1
   integer :: n2
   integer :: n3
   integer :: nd1
   integer :: nd2
   integer :: nd3
   real*8 :: z
   real*8 :: zin
  end subroutine fft3d_init
 end interface

 interface
  subroutine fft3d_vgl(n1,n2,n3,nd1,nd2,nd3,x,md1,md2,md3,y,scale,tta,ttm)
   integer :: md1
   integer :: md2
   integer :: md3
   integer :: n1
   integer :: n2
   integer :: n3
   integer :: nd1
   integer :: nd2
   integer :: nd3
   real*8 :: scale
   real*8 :: tta
   real*8 :: ttm
   real*8 :: x
   real*8 :: y
  end subroutine fft3d_vgl
 end interface

 interface
  subroutine FFT(n1,n2,n3,nd1,nd2,nd3,z,isign,inzee)
   integer :: inzee
   integer :: isign
   integer :: n1
   integer :: n2
   integer :: n3
   integer :: nd1
   integer :: nd2
   integer :: nd3
   real*8 :: z
  end subroutine FFT
 end interface

 interface
  subroutine fft3d_ctrig(n,trig,after,before,now,isign,ic)
   integer :: ic
   integer :: isign
   integer :: n
   integer :: now
   real*8 :: trig
   integer :: after(7)
   integer :: before(7)
  end subroutine fft3d_ctrig
 end interface

 interface
  subroutine fft3d_fftstp(mm,nfft,m,nn,n,zin,zout,trig,after,now,before,isign)
   integer :: after
   integer :: before
   integer :: isign
   integer :: m
   integer :: mm
   integer :: n
   integer :: nfft
   integer :: nn
   integer :: now
   real*8 :: trig
   real*8 :: zin
   real*8 :: zout
  end subroutine fft3d_fftstp
 end interface

 interface
  subroutine fftrot(mm,nfft,m,nn,n,zin,zout,trig,after,now,before,isign)
   integer :: after
   integer :: before
   integer :: isign
   integer :: m
   integer :: mm
   integer :: n
   integer :: nfft
   integer :: nn
   integer :: now
   real*8 :: trig
   real*8 :: zin
   real*8 :: zout
  end subroutine fftrot
 end interface

 interface
  subroutine gequad(nterms, p, w, urange, drange, acc)
   use defs_basis
   integer, intent(in) :: nterms
   real(dp), intent(out) :: acc
   real(dp), intent(out) :: drange
   real(dp), intent(out) :: urange
   real(dp), intent(out) :: p(nterms)
   real(dp), intent(out) :: w(nterms)
  end subroutine gequad
 end interface

 interface
  subroutine PSolver_hartree(dtset,iaction, nfft, ngfft, rhor, rprimd, vhartr)
   use defs_basis
   use defs_datatypes
   integer,intent(in) :: iaction
   integer,intent(in) :: nfft
   type(dataset_type),intent(in) :: dtset
   integer,intent(in) :: ngfft(18)
   real(dp),intent(in) :: rprimd(3,3)
   real(dp),intent(in) :: rhor(nfft)
   real(dp),intent(out) :: vhartr(nfft)
  end subroutine PSolver_hartree
 end interface

 interface
  subroutine PSolver_Kernel(n01,n02,n03,nfft1,nfft2,nfft3,&  
     hgrid,karray,xc_on,pot_ion,rhopot,ehartree,eexcu,vexcu)
   integer, intent(in) :: n01
   integer, intent(in) :: n02
   integer, intent(in) :: n03
   integer, intent(in) :: nfft1
   integer, intent(in) :: nfft2
   integer, intent(in) :: nfft3
   real*8, intent(out) :: eexcu
   real*8, intent(out) :: ehartree
   real*8, intent(in) :: hgrid
   real*8, intent(out) :: vexcu
   logical, intent(in) :: xc_on
   real*8, intent(in), dimension(nfft1/2+1,nfft2/2+1,nfft3/2+1) :: karray
   real*8, intent(in), dimension(n01,n02,n03) :: pot_ion
   real*8, intent(inout), dimension(n01,n02,n03) :: rhopot
  end subroutine PSolver_Kernel
 end interface

 interface
  subroutine kernel_application(n1,n2,n3,nd1h,nd2,nd3,nfft1,nfft2,nfft3,zarray,karray,inzee)
   integer, intent(in) :: inzee
   integer, intent(in) :: n1
   integer, intent(in) :: n2
   integer, intent(in) :: n3
   integer, intent(in) :: nd1h
   integer, intent(in) :: nd2
   integer, intent(in) :: nd3
   integer, intent(in) :: nfft1
   integer, intent(in) :: nfft2
   integer, intent(in) :: nfft3
   real*8, intent(in), dimension(nfft1/2+1,nfft2/2+1,nfft3/2+1) :: karray
   real*8, intent(inout), dimension(2,nd1h,nd2,nd3,2) :: zarray
  end subroutine kernel_application
 end interface

 interface
  subroutine norm_ind(nd1,nd2,nd3,i1,i2,i3,ind)
   integer :: i1
   integer :: i2
   integer :: i3
   integer :: ind
   integer :: nd1
   integer :: nd2
   integer :: nd3
  end subroutine norm_ind
 end interface

 interface
  subroutine symm_ind(nd1,nd2,nd3,i1,i2,i3,ind)
   integer :: i1
   integer :: i2
   integer :: i3
   integer :: ind
   integer :: nd1
   integer :: nd2
   integer :: nd3
  end subroutine symm_ind
 end interface

 interface
  subroutine symm_ind3(nd1,nd2,nd3,i1,i2,i3,a1,a2,a3)
   integer :: a1
   integer :: a2
   integer :: a3
   integer :: i1
   integer :: i2
   integer :: i3
   integer :: nd1
   integer :: nd2
   integer :: nd3
  end subroutine symm_ind3
 end interface

 interface
  subroutine zarray_in(n01,n02,n03,nd1,nd2,nd3,density,zarray)
   integer :: n01
   integer :: n02
   integer :: n03
   integer :: nd1
   integer :: nd2
   integer :: nd3
   real*8, dimension(n01,n02,n03) :: density
   real*8, dimension(2,nd1,nd2,nd3) :: zarray
  end subroutine zarray_in
 end interface

 interface
  subroutine zarray_out(n01,n02,n03,nd1,nd2,nd3,&  
     rhopot,zarray,factor,hgrid,ehartree)
   integer :: n01
   integer :: n02
   integer :: n03
   integer :: nd1
   integer :: nd2
   integer :: nd3
   real*8 :: ehartree
   real*8 :: factor
   real*8 :: hgrid
   real*8, dimension(n01,n02,n03) :: rhopot
   real*8, dimension(2*nd1,nd2,nd3) :: zarray
  end subroutine zarray_out
 end interface

 interface
  subroutine excpotu(n01,n02,n03,nd1_2,nd2,nd3,&  
     rhopot,pot_ion,zarray,factor,hgrid,ehartree,eexcu,vexcu)
   integer :: n01
   integer :: n02
   integer :: n03
   integer :: nd1_2
   integer :: nd2
   integer :: nd3
   real*8 :: eexcu
   real*8 :: ehartree
   real*8 :: factor
   real*8 :: hgrid
   real*8 :: vexcu
   real*8, dimension(n01,n02,n03) :: pot_ion
   real*8, dimension(n01,n02,n03) :: rhopot
   real*8, dimension(nd1_2,nd2,nd3) :: zarray
  end subroutine excpotu
 end interface

 interface
  subroutine check_symmetry(nd1,nd2,nd3,zarray,inzee)
   integer :: inzee
   integer :: nd1
   integer :: nd2
   integer :: nd3
   real*8 :: zarray(2,nd1*nd2*nd3,2)
  end subroutine check_symmetry
 end interface

 interface
  subroutine test_kernel(n01,n02,n03,nfft1,nfft2,nfft3,&  
     hgrid,karray,pot_ion,rhopot)
   integer :: n01
   integer :: n02
   integer :: n03
   integer :: nfft1
   integer :: nfft2
   integer :: nfft3
   real*8 :: hgrid
   real*8, dimension(nfft1/2+1,nfft2/2+1,nfft3/2+1) :: karray
   real*8, dimension(n01,n02,n03) :: pot_ion
   real*8, dimension(n01,n02,n03) :: rhopot
  end subroutine test_kernel
 end interface

 interface
  subroutine scaling_function(itype,nd,nrange,a,x)
   integer, intent(in) :: itype
   integer, intent(in) :: nd
   integer, intent(out) :: nrange
   real(kind=8), dimension(0:nd), intent(out) :: a
   real(kind=8), dimension(0:nd), intent(out) :: x
  end subroutine scaling_function
 end interface

 interface
  subroutine wavelet_function(itype,nd,a,x)
   integer, intent(in) :: itype
   integer, intent(in) :: nd
   real(kind=8), dimension(0:nd), intent(out) :: a
   real(kind=8), dimension(0:nd), intent(out) :: x
  end subroutine wavelet_function
 end interface

 interface
  subroutine scf_recursion(itype,n_iter,n_range,kernel_scf,kern_1_scf)
   integer, intent(in) :: itype
   integer, intent(in) :: n_iter
   integer, intent(in) :: n_range
   real(kind=8), intent(out) :: kern_1_scf(-n_range:n_range)
   real(kind=8), intent(inout) :: kernel_scf(-n_range:n_range)
  end subroutine scf_recursion
 end interface

 interface
  subroutine for_trans_8(nd,nt,x,y)
   integer, intent(in) :: nd
   integer, intent(in) :: nt
   real(kind=8), intent(in) :: x(0:nd-1)
   real(kind=8), intent(out) :: y(0:nd-1)
  end subroutine for_trans_8
 end interface

 interface
  subroutine back_trans_8(nd,nt,x,y)
   integer, intent(in) :: nd
   integer, intent(in) :: nt
   real(kind=8), intent(in) :: x(0:nd-1)
   real(kind=8), intent(out) :: y(0:nd-1)
  end subroutine back_trans_8
 end interface


 interface
  subroutine scf_recursion_8(n_iter,n_range,kernel_scf,kern_1_scf)
   integer, intent(in) :: n_iter
   integer, intent(in) :: n_range
   real(kind=8), intent(out) :: kern_1_scf(-n_range:n_range)
   real(kind=8), intent(inout) :: kernel_scf(-n_range:n_range)
  end subroutine scf_recursion_8
 end interface

 interface
  subroutine for_trans_14(nd,nt,x,y)
   integer, intent(in) :: nd
   integer, intent(in) :: nt
   real(kind=8), intent(in) :: x(0:nd-1)
   real(kind=8), intent(out) :: y(0:nd-1)
  end subroutine for_trans_14
 end interface

 interface
  subroutine back_trans_14(nd,nt,x,y)
   integer, intent(in) :: nd
   integer, intent(in) :: nt
   real(kind=8), intent(in) :: x(0:nd-1)
   real(kind=8), intent(out) :: y(0:nd-1)
  end subroutine back_trans_14
 end interface


 interface
  subroutine scf_recursion_14(n_iter,n_range,kernel_scf,kern_1_scf)
   integer, intent(in) :: n_iter
   integer, intent(in) :: n_range
   real(kind=8), intent(out) :: kern_1_scf(-n_range:n_range)
   real(kind=8), intent(inout) :: kernel_scf(-n_range:n_range)
  end subroutine scf_recursion_14
 end interface

 interface
  subroutine for_trans_16(nd,nt,x,y)
   integer, intent(in) :: nd
   integer, intent(in) :: nt
   real(kind=8), intent(in) :: x(0:nd-1)
   real(kind=8), intent(out) :: y(0:nd-1)
  end subroutine for_trans_16
 end interface

 interface
  subroutine back_trans_16(nd,nt,x,y)
   integer, intent(in) :: nd
   integer, intent(in) :: nt
   real(kind=8), intent(in) :: x(0:nd-1)
   real(kind=8), intent(out) :: y(0:nd-1)
  end subroutine back_trans_16
 end interface


 interface
  subroutine scf_recursion_16(n_iter,n_range,kernel_scf,kern_1_scf)
   integer, intent(in) :: n_iter
   integer, intent(in) :: n_range
   real(kind=8), intent(out) :: kern_1_scf(-n_range:n_range)
   real(kind=8), intent(inout) :: kernel_scf(-n_range:n_range)
  end subroutine scf_recursion_16
 end interface

 interface
  subroutine for_trans_20(nd,nt,x,y)
   integer, intent(in) :: nd
   integer, intent(in) :: nt
   real(kind=8), intent(in) :: x(0:nd-1)
   real(kind=8), intent(out) :: y(0:nd-1)
  end subroutine for_trans_20
 end interface

 interface
  subroutine back_trans_20(nd,nt,x,y)
   integer, intent(in) :: nd
   integer, intent(in) :: nt
   real(kind=8), intent(in) :: x(0:nd-1)
   real(kind=8), intent(out) :: y(0:nd-1)
  end subroutine back_trans_20
 end interface


 interface
  subroutine scf_recursion_20(n_iter,n_range,kernel_scf,kern_1_scf)
   integer, intent(in) :: n_iter
   integer, intent(in) :: n_range
   real(kind=8), intent(out) :: kern_1_scf(-n_range:n_range)
   real(kind=8), intent(inout) :: kernel_scf(-n_range:n_range)
  end subroutine scf_recursion_20
 end interface

 interface
  subroutine for_trans_24(nd,nt,x,y)
   integer, intent(in) :: nd
   integer, intent(in) :: nt
   real(kind=8), intent(in) :: x(0:nd-1)
   real(kind=8), intent(out) :: y(0:nd-1)
  end subroutine for_trans_24
 end interface

 interface
  subroutine back_trans_24(nd,nt,x,y)
   integer, intent(in) :: nd
   integer, intent(in) :: nt
   real(kind=8), intent(in) :: x(0:nd-1)
   real(kind=8), intent(out) :: y(0:nd-1)
  end subroutine back_trans_24
 end interface


 interface
  subroutine scf_recursion_24(n_iter,n_range,kernel_scf,kern_1_scf)
   integer, intent(in) :: n_iter
   integer, intent(in) :: n_range
   real(kind=8), intent(out) :: kern_1_scf(-n_range:n_range)
   real(kind=8), intent(inout) :: kernel_scf(-n_range:n_range)
  end subroutine scf_recursion_24
 end interface

 interface
  subroutine for_trans_30(nd,nt,x,y)
   integer, intent(in) :: nd
   integer, intent(in) :: nt
   real(kind=8), intent(in) :: x(0:nd-1)
   real(kind=8), intent(out) :: y(0:nd-1)
  end subroutine for_trans_30
 end interface

 interface
  subroutine back_trans_30(nd,nt,x,y)
   integer, intent(in) :: nd
   integer, intent(in) :: nt
   real(kind=8), intent(in) :: x(0:nd-1)
   real(kind=8), intent(out) :: y(0:nd-1)
  end subroutine back_trans_30
 end interface


 interface
  subroutine scf_recursion_30(n_iter,n_range,kernel_scf,kern_1_scf)
   integer, intent(in) :: n_iter
   integer, intent(in) :: n_range
   real(kind=8), intent(out) :: kern_1_scf(-n_range:n_range)
   real(kind=8), intent(inout) :: kernel_scf(-n_range:n_range)
  end subroutine scf_recursion_30
 end interface

 interface
  subroutine for_trans_40(nd,nt,x,y)
   integer, intent(in) :: nd
   integer, intent(in) :: nt
   real(kind=8), intent(in) :: x(0:nd-1)
   real(kind=8), intent(out) :: y(0:nd-1)
  end subroutine for_trans_40
 end interface

 interface
  subroutine back_trans_40(nd,nt,x,y)
   integer, intent(in) :: nd
   integer, intent(in) :: nt
   real(kind=8), intent(in) :: x(0:nd-1)
   real(kind=8), intent(out) :: y(0:nd-1)
  end subroutine back_trans_40
 end interface


 interface
  subroutine scf_recursion_40(n_iter,n_range,kernel_scf,kern_1_scf)
   integer, intent(in) :: n_iter
   integer, intent(in) :: n_range
   real(kind=8), intent(out) :: kern_1_scf(-n_range:n_range)
   real(kind=8), intent(inout) :: kernel_scf(-n_range:n_range)
  end subroutine scf_recursion_40
 end interface

 interface
  subroutine for_trans_50(nd,nt,x,y)
   integer, intent(in) :: nd
   integer, intent(in) :: nt
   real(kind=8), intent(in) :: x(0:nd-1)
   real(kind=8), intent(out) :: y(0:nd-1)
  end subroutine for_trans_50
 end interface

 interface
  subroutine back_trans_50(nd,nt,x,y)
   integer, intent(in) :: nd
   integer, intent(in) :: nt
   real(kind=8), intent(in) :: x(0:nd-1)
   real(kind=8), intent(out) :: y(0:nd-1)
  end subroutine back_trans_50
 end interface


 interface
  subroutine scf_recursion_50(n_iter,n_range,kernel_scf,kern_1_scf)
   integer, intent(in) :: n_iter
   integer, intent(in) :: n_range
   real(kind=8), intent(out) :: kern_1_scf(-n_range:n_range)
   real(kind=8), intent(inout) :: kernel_scf(-n_range:n_range)
  end subroutine scf_recursion_50
 end interface

 interface
  subroutine for_trans_60(nd,nt,x,y)
   integer, intent(in) :: nd
   integer, intent(in) :: nt
   real(kind=8), intent(in) :: x(0:nd-1)
   real(kind=8), intent(out) :: y(0:nd-1)
  end subroutine for_trans_60
 end interface

 interface
  subroutine back_trans_60(nd,nt,x,y)
   integer, intent(in) :: nd
   integer, intent(in) :: nt
   real(kind=8), intent(in) :: x(0:nd-1)
   real(kind=8), intent(out) :: y(0:nd-1)
  end subroutine back_trans_60
 end interface


 interface
  subroutine scf_recursion_60(n_iter,n_range,kernel_scf,kern_1_scf)
   integer, intent(in) :: n_iter
   integer, intent(in) :: n_range
   real(kind=8), intent(out) :: kern_1_scf(-n_range:n_range)
   real(kind=8), intent(inout) :: kernel_scf(-n_range:n_range)
  end subroutine scf_recursion_60
 end interface

 interface
  subroutine for_trans_100(nd,nt,x,y)
   integer, intent(in) :: nd
   integer, intent(in) :: nt
   real(kind=8), intent(in) :: x(0:nd-1)
   real(kind=8), intent(out) :: y(0:nd-1)
  end subroutine for_trans_100
 end interface

 interface
  subroutine back_trans_100(nd,nt,x,y)
   integer, intent(in) :: nd
   integer, intent(in) :: nt
   real(kind=8), intent(in) :: x(0:nd-1)
   real(kind=8), intent(out) :: y(0:nd-1)
  end subroutine back_trans_100
 end interface


 interface
  subroutine scf_recursion_100(n_iter,n_range,kernel_scf,kern_1_scf)
   integer, intent(in) :: n_iter
   integer, intent(in) :: n_range
   real(kind=8), intent(out) :: kern_1_scf(-n_range:n_range)
   real(kind=8), intent(inout) :: kernel_scf(-n_range:n_range)
  end subroutine scf_recursion_100
 end interface

 interface
  subroutine razero(n,x)
   integer, intent(in) :: n
   real*8, intent(out) :: x(n)
  end subroutine razero
 end interface

end module interfaces_02poisson
!!***
