!!****m* ABINIT/interfaces_03ionetcdf
!! NAME
!! interfaces_03ionetcdf
!!
!! FUNCTION
!! This module contains the interfaces of the routines
!! in the directory src/03ionetcdf
!!
!! COPYRIGHT
!! Copyright (C) 2005 ABINIT group
!! This file is distributed under the terms of the
!! GNU General Public License, see ~abinit/COPYING
!! or http://www.gnu.org/copyleft/gpl.txt .
!!
!! NOTES
!! THIS FILE IS GENERATED AUTOMATICALLY BY abilint.
!! To do that: abilint . .
!!             (see util/maintainers/abilint.py)
!!
!! SOURCE

module interfaces_03ionetcdf

 interface
  subroutine netcdf_data_read(ncid,blocks,dtset,wfs,den,acfd)
   use defs_basis
   use defs_datatypes
   use defs_netcdf
   integer,intent(in) :: blocks
   integer,intent(in) :: ncid
   type(ncacfd_type),intent(inout),optional :: acfd
   type(dataset_type),intent(inout),optional :: dtset
   real(dp),intent(inout),optional :: den(:,:)
   real(dp),intent(inout),optional :: wfs(:,:)
  end subroutine netcdf_data_read
 end interface

 interface
  subroutine netcdf_file_write(ncid,blocks,dtset,wfs,den,acfd)
   use defs_basis
   use defs_datatypes
   use defs_netcdf
   integer,intent(in) :: blocks
   integer,intent(in) :: ncid
   type(ncacfd_type),intent(in),optional :: acfd
   type(dataset_type),intent(in),optional :: dtset
   real(dp),intent(in),optional :: den(:,:)
   real(dp),intent(in),optional :: wfs(:,:)
  end subroutine netcdf_file_write
 end interface

 interface
  subroutine netcdf_def_acfd(ncid,nfreqsus,npw_tiny)
   integer,intent(in) :: ncid
   integer,intent(in) :: nfreqsus
   integer,intent(in) :: npw_tiny
  end subroutine netcdf_def_acfd
 end interface

 interface
  subroutine netcdf_def_den(ncid,nfft,nspden)
   integer,intent(in) :: ncid
   integer,intent(in) :: nfft
   integer,intent(in) :: nspden
  end subroutine netcdf_def_den
 end interface

 interface
  subroutine netcdf_def_dtset(ncid,dims)
   use defs_datatypes
   integer,intent(in) :: ncid
   type(vardims_type),intent(in) :: dims
  end subroutine netcdf_def_dtset
 end interface

 interface
  subroutine netcdf_def_wfs(ncid,wfs_dim1,wfs_dim2)
   integer,intent(in) :: ncid
   integer,intent(in) :: wfs_dim1
   integer,intent(in) :: wfs_dim2
  end subroutine netcdf_def_wfs
 end interface

 interface
  subroutine netcdf_dims_read(ncid,blocks,dims)
   use defs_datatypes
   integer,intent(in) :: blocks
   integer,intent(in) :: ncid
   type(vardims_type),intent(out) :: dims
  end subroutine netcdf_dims_read
 end interface

 interface
  subroutine netcdf_file_close(ncid)
   integer,intent(in) :: ncid
  end subroutine netcdf_file_close
 end interface

 interface
  subroutine netcdf_file_create(ncid,filename,blocks,dims)
   use defs_datatypes
   integer,intent(in) :: blocks
   integer,intent(inout) :: ncid
   type(vardims_type),intent(in) :: dims
   character(len=*),intent(in) :: filename
  end subroutine netcdf_file_create
 end interface

 interface
  subroutine netcdf_get_acfd(ncid,acfd)
   use defs_netcdf
   integer,intent(in) :: ncid
   type(ncacfd_type),intent(out) :: acfd
  end subroutine netcdf_get_acfd
 end interface

 interface
  subroutine netcdf_get_den(ncid,rhor)
   use defs_basis
   integer,intent(in) :: ncid
   real(dp),intent(out) :: rhor(:,:)
  end subroutine netcdf_get_den
 end interface

 interface
  subroutine netcdf_get_dims_acfd(ncid,dims)
   use defs_datatypes
   integer,intent(in) :: ncid
   type(vardims_type),intent(out) :: dims
  end subroutine netcdf_get_dims_acfd
 end interface

 interface
  subroutine netcdf_get_dims_den(ncid,dims)
   use defs_datatypes
   integer,intent(in) :: ncid
   type(vardims_type),intent(out) :: dims
  end subroutine netcdf_get_dims_den
 end interface

 interface
  subroutine netcdf_get_dims_dtset(ncid,dims)
   use defs_datatypes
   integer,intent(in) :: ncid
   type(vardims_type),intent(inout) :: dims
  end subroutine netcdf_get_dims_dtset
 end interface

 interface
  subroutine netcdf_get_dims_wfs(ncid,dims)
   use defs_datatypes
   integer,intent(in) :: ncid
   type(vardims_type),intent(out) :: dims
  end subroutine netcdf_get_dims_wfs
 end interface

 interface
  subroutine netcdf_get_dtset(ncid,dtset)
   use defs_datatypes
   integer,intent(in) :: ncid
   type(dataset_type),intent(inout) :: dtset
  end subroutine netcdf_get_dtset
 end interface

 interface
  subroutine netcdf_get_wfs(ncid,wfs)
   use defs_basis
   integer,intent(in) :: ncid
   real(dp),intent(out) :: wfs(:,:)
  end subroutine netcdf_get_wfs
 end interface

 interface
  subroutine netcdf_handle_error(omode,otype,tgt,parent,ncerr)
   integer,intent(in) :: ncerr
   character(len=3),intent(in) :: omode
   character(len=3),intent(in) :: otype
   character(len=*),intent(in) :: parent
   character(len=*),intent(in) :: tgt
  end subroutine netcdf_handle_error
 end interface

 interface
  subroutine netcdf_put_acfd(ncid,acfd)
   use defs_netcdf
   integer,intent(in) :: ncid
   type(ncacfd_type),intent(in) :: acfd
  end subroutine netcdf_put_acfd
 end interface

 interface
  subroutine netcdf_put_den(ncid,rhor)
   use defs_basis
   integer,intent(in) :: ncid
   real(dp),intent(in) :: rhor(:,:)
  end subroutine netcdf_put_den
 end interface

 interface
  subroutine netcdf_put_dtset(ncid,dtset)
   use defs_datatypes
   integer,intent(in) :: ncid
   type(dataset_type),intent(in) :: dtset
  end subroutine netcdf_put_dtset
 end interface

 interface
  subroutine netcdf_put_wfs(ncid,wfs)
   use defs_basis
   integer,intent(in) :: ncid
   real(dp),intent(in) :: wfs(:,:)
  end subroutine netcdf_put_wfs
 end interface

end module interfaces_03ionetcdf
!!***
