!!****m* ABINIT/interfaces_06geomoptim
!! NAME
!! interfaces_06geomoptim
!!
!! FUNCTION
!! This module contains the interfaces of the routines
!! in the directory src/06geomoptim
!!
!! COPYRIGHT
!! Copyright (C) 2005 ABINIT group
!! This file is distributed under the terms of the
!! GNU General Public License, see ~abinit/COPYING
!! or http://www.gnu.org/copyleft/gpl.txt .
!!
!! NOTES
!! THIS FILE IS GENERATED AUTOMATICALLY BY abilint.
!! To do that: abilint . .
!!             (see util/maintainers/abilint.py)
!!
!! SOURCE

module interfaces_06geomoptim

 interface
  subroutine calc_b_matrix(angs,bonds,carts,dihedrals,nbond,nang,ndihed,ncart,ninternal,&  
&  dtset,nrshift,rprimd,rshift,xcart,b_matrix)
   use defs_basis
   use defs_datatypes
   integer,intent(in) :: nang
   integer,intent(in) :: nbond
   integer,intent(in) :: ncart
   integer,intent(in) :: ndihed
   integer,intent(in) :: ninternal
   integer,intent(in) :: nrshift
   type(dataset_type),intent(in) :: dtset
   integer,pointer :: angs(:,:,:)
   integer,pointer :: bonds(:,:,:)
   integer,pointer :: carts(:,:)
   integer,pointer :: dihedrals(:,:,:)
   real(dp),intent(in) :: rprimd(3,3)
   real(dp),intent(out) :: b_matrix(ninternal,3*dtset%natom)
   real(dp),intent(in) :: rshift(3,nrshift)
   real(dp),intent(in) :: xcart(3,dtset%natom)
  end subroutine calc_b_matrix
 end interface

 interface
  subroutine dbond_length_d1(r1,r2,bb)
   use defs_basis
   real(dp),intent(out) :: bb(3)
   real(dp),intent(in) :: r1(3)
   real(dp),intent(in) :: r2(3)
  end subroutine dbond_length_d1
 end interface

 interface
  subroutine dang_d1(r1,r2,r3,bb)
   use defs_basis
   real(dp),intent(out) :: bb(3)
   real(dp),intent(in) :: r1(3)
   real(dp),intent(in) :: r2(3)
   real(dp),intent(in) :: r3(3)
  end subroutine dang_d1
 end interface

 interface
  subroutine dang_d2(r1,r2,r3,bb)
   use defs_basis
   real(dp),intent(out) :: bb(3)
   real(dp),intent(in) :: r1(3)
   real(dp),intent(in) :: r2(3)
   real(dp),intent(in) :: r3(3)
  end subroutine dang_d2
 end interface

 interface
  subroutine ddihedral_d1(r1,r2,r3,r4,bb)
   use defs_basis
   real(dp),intent(out) :: bb(3)
   real(dp),intent(in) :: r1(3)
   real(dp),intent(in) :: r2(3)
   real(dp),intent(in) :: r3(3)
   real(dp),intent(in) :: r4(3)
  end subroutine ddihedral_d1
 end interface

 interface
  subroutine ddihedral_d2(r1,r2,r3,r4,bb)
   use defs_basis
   real(dp),intent(out) :: bb(3)
   real(dp),intent(in) :: r1(3)
   real(dp),intent(in) :: r2(3)
   real(dp),intent(in) :: r3(3)
   real(dp),intent(in) :: r4(3)
  end subroutine ddihedral_d2
 end interface

 interface
  subroutine calc_prim_int(angs,bonds,carts,dihedrals,nbond,nang,ndihed,ncart,ninternal,&  
&  dtset,nrshift,rprimd,rshift,xcart,prim_int)
   use defs_basis
   use defs_datatypes
   integer,intent(in) :: nang
   integer,intent(in) :: nbond
   integer,intent(in) :: ncart
   integer,intent(in) :: ndihed
   integer,intent(in) :: ninternal
   integer,intent(in) :: nrshift
   type(dataset_type),intent(in) :: dtset
   integer,pointer :: angs(:,:,:)
   integer,pointer :: bonds(:,:,:)
   integer,pointer :: carts(:,:)
   integer,pointer :: dihedrals(:,:,:)
   real(dp),intent(in) :: rprimd(3,3)
   real(dp),intent(out) :: prim_int(ninternal)
   real(dp),intent(in) :: rshift(3,nrshift)
   real(dp),intent(in) :: xcart(3,dtset%natom)
  end subroutine calc_prim_int
 end interface

 interface
  function bond_length(r1,r2)
   use defs_basis
   real(dp) :: bond_length
   real(dp), intent(in) :: r1(3)
   real(dp), intent(in) :: r2(3)
  end function bond_length
 end interface

 interface
  function angle_ang(r1,r2,r3)
   use defs_basis
   real(dp) :: angle_ang
   real(dp), intent(in) :: r1(3)
   real(dp), intent(in) :: r2(3)
   real(dp), intent(in) :: r3(3)
  end function angle_ang
 end interface

 interface
  function angle_dihedral(r1,r2,r3,r4)
   use defs_basis
   real(dp) :: angle_dihedral
   real(dp),intent(in) :: r1(3)
   real(dp),intent(in) :: r2(3)
   real(dp),intent(in) :: r3(3)
   real(dp),intent(in) :: r4(3)
  end function angle_dihedral
 end interface

 interface
  subroutine deloc2xcart(angs,bonds,carts,dihedrals,nbond,nang,ndihed,ncart,ninternal,nrshift,&  
&  dtset,rprimd,rshift,xcart,&  
&  deloc_int,btinv,u_matrix)
   use defs_basis
   use defs_datatypes
   integer,intent(in) :: nang
   integer,intent(in) :: nbond
   integer,intent(in) :: ncart
   integer,intent(in) :: ndihed
   integer,intent(in) :: ninternal
   integer,intent(in) :: nrshift
   type(dataset_type),intent(in) :: dtset
   integer,pointer :: angs(:,:,:)
   integer,pointer :: bonds(:,:,:)
   integer,pointer :: carts(:,:)
   integer,pointer :: dihedrals(:,:,:)
   real(dp),intent(in) :: rprimd(3,3)
   real(dp),intent(out) :: btinv(3*(dtset%natom-1),3*dtset%natom)
   real(dp),intent(in) :: deloc_int(3*(dtset%natom-1))
   real(dp),intent(in) :: rshift(3,nrshift)
   real(dp),intent(inout) :: u_matrix(ninternal,3*(dtset%natom-1))
   real(dp),intent(inout) :: xcart(3,dtset%natom)
  end subroutine deloc2xcart
 end interface

 interface
  function get_mix(x1,y1,x2,y2,x3,y3)
   use defs_basis
   real(dp) :: get_mix
   real(dp),intent(in) :: x1
   real(dp),intent(in) :: x2
   real(dp),intent(in) :: x3
   real(dp),intent(in) :: y1
   real(dp),intent(in) :: y2
   real(dp),intent(in) :: y3
  end function get_mix
 end interface

 interface
  subroutine delocint(acell,atindx,atindx1,atmrhoij,cg,cpus,densymop_gs,dtefield,dtfil,&  
&  dtset,ecore,eigen,gsc,hdr,indsym,initialized,irrzon,&  
&  kg,mpi_enreg,mxfh,&  
&  nattyp,nfftf,npwarr,nspinor,nxfh,occ,&  
&  pawang,pawfgr,pawrad,pawtab,phnons,psps,pwind,pwind_alloc,pwnsfac,resid,results_gs,&  
&  rhog,rhor,rprim,swfnew,swfnow,symrec,wffnew,wffnow,vel,&  
&  xfhist,xred,xred_old,ylm,ylmgr)
   use defs_basis
   use defs_datatypes
   integer,intent(inout) :: initialized
   integer,intent(in) :: mxfh
   integer,intent(in) :: nfftf
   integer,intent(inout) :: nspinor
   integer,intent(inout) :: nxfh
   integer,intent(in) :: pwind_alloc
   real(dp),intent(in) :: cpus
   type(dens_sym_operator_type),intent(inout) :: densymop_gs
   type(efield_type),intent(inout) :: dtefield
   type(datafiles_type),intent(in) :: dtfil
   type(dataset_type),intent(inout) :: dtset
   real(dp),intent(in) :: ecore
   type(hdr_type),intent(inout) :: hdr
   type(MPI_type),intent(inout) :: mpi_enreg
   type(pawang_type),intent(in) :: pawang
   type(pawfgr_type) :: pawfgr
   type(pseudopotential_type),intent(in) :: psps
   type(results_gs_type),intent(out) :: results_gs
   type(wffile_type),intent(inout) :: swfnew
   type(wffile_type),intent(inout) :: swfnow
   type(wffile_type),intent(inout) :: wffnew
   type(wffile_type),intent(inout) :: wffnow
   real(dp), intent(inout) :: acell(3)
   real(dp), intent(inout) :: rprim(3,3)
   integer,intent(in) :: atindx(dtset%natom)
   integer,intent(in) :: atindx1(dtset%natom)
   type(atmrhoij_type), intent(inout) :: atmrhoij(dtset%natom*psps%usepaw)
   real(dp), intent(inout) :: cg(2,dtset%mpw*nspinor*dtset%mband*dtset%mkmem*dtset%nsppol)
   real(dp), intent(out) :: eigen(dtset%mband*dtset%nkpt*dtset%nsppol)
   real(dp), intent(inout) :: gsc(2,dtset%mpw*nspinor*dtset%mband*dtset%mkmem*dtset%nsppol*psps%usepaw)
   integer,intent(inout) :: indsym(4,dtset%nsym,dtset%natom)
   integer, intent(inout) :: irrzon(dtset%nfft**(1-1/dtset%nsym),2,dtset%nspden/dtset%nsppol)
   integer, intent(in) :: kg(3,dtset%mpw*dtset%mkmem)
   integer, intent(in) :: nattyp(psps%ntypat)
   integer, intent(in) :: npwarr(dtset%nkpt)
   real(dp), intent(inout) :: occ(dtset%mband*dtset%nkpt*dtset%nsppol)
   type(pawrad_type), intent(in) :: pawrad(psps%ntypat*psps%usepaw)
   type(pawtab_type), intent(in) :: pawtab(psps%ntypat*psps%usepaw)
   real(dp), intent(inout) :: phnons(2,dtset%nfft**(1-1/dtset%nsym),dtset%nspden/dtset%nsppol)
   integer, intent(in) :: pwind(pwind_alloc,2,3)
   real(dp), intent(in) :: pwnsfac(2,pwind_alloc)
   real(dp), intent(out) :: resid(dtset%mband*dtset%nkpt*dtset%nsppol)
   real(dp), intent(inout) :: rhog(2,nfftf)
   real(dp), intent(inout) :: rhor(nfftf,dtset%nspden)
   integer, intent(inout) :: symrec(3,3,dtset%nsym)
   real(dp), intent(in) :: vel(3,dtset%natom)
   real(dp), intent(inout) :: xfhist(3,dtset%natom+4,2,mxfh)
   real(dp), intent(inout) :: xred(3,dtset%natom)
   real(dp), intent(inout) :: xred_old(3,dtset%natom)
   real(dp), intent(inout) :: ylm(dtset%mpw*dtset%mkmem,psps%mpsang*psps%mpsang*psps%useylm)
   real(dp), intent(inout) :: ylmgr(dtset%mpw*dtset%mkmem,3,psps%mpsang*psps%mpsang*psps%useylm)
  end subroutine delocint
 end interface

 interface
  subroutine fred2fdeloc(btinv,deloc_force,fred,dtset,rprimd)
   use defs_basis
   use defs_datatypes
   type(dataset_type),intent(in) :: dtset
   real(dp),intent(in) :: rprimd(3,3)
   real(dp),intent(in) :: btinv(3*(dtset%natom-1),3*dtset%natom)
   real(dp),intent(out) :: deloc_force(3*(dtset%natom-1))
   real(dp),intent(out) :: fred(3,dtset%natom)
  end subroutine fred2fdeloc
 end interface

 interface
  subroutine make_angles(angs,bonds,icenter,nang,nbond,dtset)
   use defs_datatypes
   integer,intent(in) :: icenter
   integer,intent(out) :: nang
   integer,intent(in) :: nbond
   type(dataset_type),intent(in) :: dtset
   integer,pointer :: angs(:,:,:)
   integer,pointer :: bonds(:,:,:)
  end subroutine make_angles
 end interface

 interface
  subroutine make_bonds(bonds,nbond,dtset,icenter,nrshift,rprimd,rshift,xcart)
   use defs_basis
   use defs_datatypes
   integer,intent(in) :: icenter
   integer,intent(out) :: nbond
   integer,intent(in) :: nrshift
   type(dataset_type),intent(in) :: dtset
   integer,pointer :: bonds(:,:,:)
   real(dp),intent(in) :: rprimd(3,3)
   real(dp),intent(in) :: rshift(3,nrshift)
   real(dp),intent(in) :: xcart(3,dtset%natom)
  end subroutine make_bonds
 end interface

 interface
  subroutine make_dihedrals(angs,badangles,bonds,dihedrals,icenter,nbond,nang,ndihed,nrshift,dtset)
   use defs_datatypes
   integer,intent(in) :: icenter
   integer,intent(in) :: nang
   integer,intent(in) :: nbond
   integer,intent(out) :: ndihed
   integer,intent(in) :: nrshift
   type(dataset_type),intent(in) :: dtset
   integer,pointer :: angs(:,:,:)
   integer,pointer :: bonds(:,:,:)
   integer,pointer :: dihedrals(:,:,:)
   integer,intent(in) :: badangles(nang)
  end subroutine make_dihedrals
 end interface

 interface
  subroutine make_prim_internals(angs,bonds,carts,dihedrals,icenter,nbond,nang,ndihed,ncart,&  
&  dtset,nrshift,rprimd,rshift,xcart)
   use defs_basis
   use defs_datatypes
   integer,intent(in) :: icenter
   integer,intent(out) :: nang
   integer,intent(out) :: nbond
   integer,intent(out) :: ncart
   integer,intent(out) :: ndihed
   integer,intent(in) :: nrshift
   type(dataset_type),intent(in) :: dtset
   integer,pointer :: angs(:,:,:)
   integer,pointer :: bonds(:,:,:)
   integer,pointer :: carts(:,:)
   integer,pointer :: dihedrals(:,:,:)
   real(dp),intent(in) :: rprimd(3,3)
   real(dp),intent(in) :: rshift(3,nrshift)
   real(dp),intent(in) :: xcart(3,dtset%natom)
  end subroutine make_prim_internals
 end interface

 interface
  subroutine xcart2deloc(angs,bonds,carts,dihedrals,nbond,nang,ndihed,ncart,ninternal,&  
&  dtset,nrshift,rprimd,rshift,xcart,&  
&  bt_inv_matrix,u_matrix,deloc_int,prim_int)
   use defs_basis
   use defs_datatypes
   integer,intent(in) :: nang
   integer,intent(in) :: nbond
   integer,intent(in) :: ncart
   integer,intent(in) :: ndihed
   integer,intent(in) :: ninternal
   integer,intent(in) :: nrshift
   type(dataset_type),intent(in) :: dtset
   integer,pointer :: angs(:,:,:)
   integer,pointer :: bonds(:,:,:)
   integer,pointer :: carts(:,:)
   integer,pointer :: dihedrals(:,:,:)
   real(dp),intent(in) :: rprimd(3,3)
   real(dp),intent(out) :: bt_inv_matrix(3*(dtset%natom-1),3*dtset%natom)
   real(dp),intent(out) :: deloc_int(3*(dtset%natom-1))
   real(dp),intent(out) :: prim_int(ninternal)
   real(dp),intent(in) :: rshift(3,nrshift)
   real(dp),intent(inout) :: u_matrix(ninternal,3*(dtset%natom-1))
   real(dp),intent(in) :: xcart(3,dtset%natom)
  end subroutine xcart2deloc
 end interface

 interface
  subroutine calc_btinv_matrix(b_matrix,dtset,nang,nbond,ndihed,ncart,ninternal,&  
&  bt_inv_matrix,u_matrix)
   use defs_basis
   use defs_datatypes
   integer,intent(in) :: nang
   integer,intent(in) :: nbond
   integer,intent(in) :: ncart
   integer,intent(in) :: ndihed
   integer,intent(in) :: ninternal
   type(dataset_type),intent(in) :: dtset
   real(dp),intent(in) :: b_matrix(ninternal,3*dtset%natom)
   real(dp),intent(out) :: bt_inv_matrix(3*(dtset%natom-1),3*dtset%natom)
   real(dp),intent(inout) :: u_matrix(ninternal,3*(dtset%natom-1))
  end subroutine calc_btinv_matrix
 end interface

 interface
  subroutine align_u_matrices(dtset,ninternal,u_matrix,u_matrix_old,s_matrix,f_eigs)
   use defs_basis
   use defs_datatypes
   integer, intent(in) :: ninternal
   type(dataset_type), intent(in) :: dtset
   real(dp), intent(inout) :: f_eigs(3*dtset%natom)
   real(dp), intent(inout) :: s_matrix(3*dtset%natom,3*dtset%natom)
   real(dp), intent(inout) :: u_matrix(ninternal,3*(dtset%natom-1))
   real(dp), intent(in) :: u_matrix_old(ninternal,3*(dtset%natom-1))
  end subroutine align_u_matrices
 end interface

 interface
  subroutine cross_product(r1,r2,cp)
   use defs_basis
   real(dp), intent(out) :: cp(3)
   real(dp), intent(in) :: r1(3)
   real(dp), intent(in) :: r2(3)
  end subroutine cross_product
 end interface

 interface
  subroutine xcart2deloc_fixb(angs,bonds,carts,dihedrals,nbond,nang,ndihed,ncart,ninternal,&  
&  dtset,nrshift,rprimd,rshift,xcart,&  
&  u_matrix,deloc_int,prim_int)
   use defs_basis
   use defs_datatypes
   integer,intent(in) :: nang
   integer,intent(in) :: nbond
   integer,intent(in) :: ncart
   integer,intent(in) :: ndihed
   integer,intent(in) :: ninternal
   integer,intent(in) :: nrshift
   type(dataset_type),intent(in) :: dtset
   integer,pointer :: angs(:,:,:)
   integer,pointer :: bonds(:,:,:)
   integer,pointer :: carts(:,:)
   integer,pointer :: dihedrals(:,:,:)
   real(dp),intent(in) :: rprimd(3,3)
   real(dp),intent(out) :: deloc_int(3*(dtset%natom-1))
   real(dp),intent(out) :: prim_int(ninternal)
   real(dp),intent(in) :: rshift(3,nrshift)
   real(dp),intent(in) :: u_matrix(ninternal,3*(dtset%natom-1))
   real(dp),intent(in) :: xcart(3,dtset%natom)
  end subroutine xcart2deloc_fixb
 end interface

end module interfaces_06geomoptim
!!***
